unit UltraUserStrings;

// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you maynot use this file except in compliance
// with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
//
// Alternatively, you may redistribute this library, use and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software Foundation;
// either version 2.1 of the License, or (at your option) any later version.
// You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
// specific language governing rights and limitations under the License.

interface

uses
  DKLang, MPResources, VirtualResources;
                                          
const
  MAX_OPTIONFRAMES = 18;

  // Configuration Files
  STR_VERSION_FILE = 'Version.htm';
  STR_TAG_FILE = 'UltraExplorer.id';
  STR_FILTERSETTINGS_FILE = 'UltraFilters.cfg';  // depreciated due to creating custom items in the listview
  STR_FILTERSETTINGSNEW_FILE = 'UltraFilterMask.cfg';
  STR_CUSTOMIZATIONSETTINGS_FILE = 'UltraCustomization.cfg';
  STR_FAVORITESETTINGS_FILE = 'UltraFavorites.cfg';
  STR_OPTIONSETTINGS_FILE = 'UltraOptions.cfg';
  STR_LAYOUTSETTINGS_FILE = 'UltraLayout.cfg';
  STR_MISCSETTINGS_FILE = 'UltraMisc.cfg';
  STR_LAUNCH_VERBS_FILE_OLD = 'LaunchVerbs.txt';
  STR_LAUNCH_VERBS_FILE = 'LaunchVerbs.cfg';
  STR_LAUNCHER_FILE = 'Launchers.cfg';
  STR_EXTENSIONCOLORCODE_FILE = 'UltraFileColors.cfg';
  STR_FLATTENFOLDER_FILE = 'UltraFlattenFolder.cfg';
  STR_WHATSNEW_FILE = 'Documentation\Whats New.txt';
  STR_EELFOLDERSETTINGS_FILE = 'ListviewFolderSettings.cfg';
  STR_EELFIXEDFOLDERSETTINGS_FILE = 'ListviewFixedFolderSettings.cfg';
  STR_TEMP_LIST_FILE = 'UE_Temp_File.tmp';
  STR_HELPLANGUAGETRANSLATE = '\Language\LanguageHelp.rtf';
  STR_URL_DKLANG = 'http://www.dk-soft.org/products/dklang/index.php?lang=en';
  STR_URL_DKLANG_INSTRUCTIONS = '\Language\LanguageHelp.rtf';
  STR_FAVORITESPIDL_FILE = 'FavoritesPIDL.dat';
  STR_TASKLIB_FOLDER = 'Plugin Tasks';
  STR_TASKLIB_EXT = '.dll';
  STR_HISTORYFILE = '\History.txt';
  STR_FILESYNCMUTEX = 'UltraFileSyncMutex';
  STR_SINGLEINSTANCEMUTEX = 'UltraSingleInstanceMutex';

  // Registry
  STR_ULTRAEXPLORER_REG_KEY = 'SOFTWARE\Mustangpeak\UltraExplorer';

  // Help Files
  STR_HELPFILENAME = 'UltraExplorer.chm';
  STR_WIKIHELP = 'http://www.wiki.mustangpeak.net/index.php?title=UltraExplorer';

  MAILTO_SUBJECT = WideString('UltraExplorer Feedback');
  MAILTO_BODY = WideString('Thanks for using UltraExplorer');
  MAILTO_MAIL = WideString('mailto:jim@mustangpeak.net?subject=' + MAILTO_SUBJECT +'&body=' + MAILTO_BODY);

  STR_MUSTANGPEAK_URL = WideString('www.mustangpeak.net');
  STR_DOWNLOADURL = WideString('www.mustangpeak.net/download/ultraexplorer/UltraExplorerSetup.exe');

  STR_INVALID_INTEGER = 'Invalid integer format. Please enter a valid integer value';
  NUMERIC_KEYS = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0'];
  FLOAT_KEYS = ['e', 'E', '-', '+', '.'];

type
  TFrameCaptions = array[0..MAX_OPTIONFRAMES-1] of WideString; // Update to add more nodes to the Options Treeview

var
  STR_FILTER_FOLDERS: WideString = 'Folders';
  STR_FILTEROUT: WideString = 'Filter Out';
  STR_FILTERIN: WideString = 'Filter In';
  STR_OBJECTS: WideString = 'Objects';
  STR_OBJECTS_SELECTED: WideString = 'Objects Selected';
  STR_SELECTED: WideString = 'Selected';
  STR_FAVORITES_DROP_WARNING: WideString = 'This operation will move/copy files into the target folder.  Are you sure this is what you want to do? (This warning may be shut off in the Options dialog on the Favorites tab.)';
  STR_FAVORITES_CONTEXT_WARNING: WideString = 'This operation will act on the underlying file or folder.  To edit the Favorites view select the "Edit" button in the Toolbar.  Are you sure this is what you want to do?';
  STR_HISTORY_CONTEXT_WARNING: WideString = 'This operation will act on the underlying file or folder.  Are you sure this is what you want to do?';
  STR_HISTORY_DROP_WARNING: WideString = 'This operation will act on the underlying file or folder.  Are you sure this is what you want to do?';
  STR_WARNING: WideString = 'Warning';
  STR_LOADINGPLUGIN: WideString = 'Loading Plugin';
  STR_NOFILESELECTED: WideString = 'No File Selected';
  STR_VIEWERCAPTION: WideString = 'Viewer';
  STR_CONFIRM: WideString = 'Confirm';
  STR_PROPERTIES: WideString = 'Properties';
  STR_ULTRAEXPLORER: WideString = 'UltraExplorer';
  STR_LANGUAGEHELPME: WideString = 'Help Translate a Language';

  STR_NEW_VERSION_AVIALABLE: WideString = 'Available';
  STR_NEW_VERSION_FILE_URL: WideString = STR_MUSTANGPEAK_URL + '/' + STR_VERSION_FILE;
  STR_AUTOUPDATE_CHECK: WideString = 'UltraExplorer Updater';
  STR_AUTOUPDATE_AVAILABLEPOST: WideString = 'is available.  Download now?';
  STR_AUTOUPDATE_NOTAVAILABLE: WideString = 'Sorry, a new version of UltraExplorer is not available';
  STR_AUTOUPDATE_CONNECTFAILED: WideString = 'Unable to connect to the mustangpeak.net website.' + #13#10 + 'Please check your internet connection.';

  STR_FTPNEWPROFILE: WideString = 'New Profile';
  STR_FTPPROFILESAVE: WideString = 'The FTP Connection profiles have changed.  Would you like to save?';

  STR_GROUPINGEDITFILESIZE: WideString = 'File Size';
  STR_GROUPINGEDITMODIFIEDDATE: WideString = 'Days ago';
  STR_GROUPINGEDITMODIFIEDNEW: WideString = 'New Criteria';
  STR_GROUPINGFOLDEROBJECTS: WideString = 'Folder Objects';
  STR_GROUPINGSPECIALFOLDEROBJECTS: WideString = 'Special Folder Objects';

  STR_CAPTION: WideString = 'Caption';
  STR_FILESIZE: WideString = 'File Size';
  STR_MODIFYDATE: WideString = 'Modify Date';

  STR_VIEW: WideString = 'View';
  STR_ICONVIEW: WideString = 'Icon';
  STR_SMALLICONVIEW: WideString = 'Small Icon';
  STR_LISTVIEW: WideString = 'List';
  STR_DETAILSVIEW: WideString = 'Details';
  STR_TILEVIEW: WideString = 'Tile';
  STR_THUMBNAILVIEW: WideString =  'Thumbnail';
  STR_ARRANGE_NAME: WideString =  'Name';
  STR_ARRANGE_SIZE: WideString =  'Size';
  STR_ARRANGE_TYPE: WideString =  'Type';
  STR_ARRANGE_MODIFIED: WideString =  'Modified';
  STR_ARRANGE_GROUPS: WideString =  'Show in Groups';
  STR_FREESPACE: WideString =  'Freespace';
  STR_DRIVE: WideString =  'Drive';
  STR_SIZE: WideString =  'Size';
  STR_CHOOSEWORKINGDIR: WideString = 'Choose Working Folder';
  STR_COPY_TO_DROPSTACK: WideString = 'Copy to DropStack';
  STR_REMOVE_FAV_ITEM: WideString = 'Remove Favorite Item';

  STR_PLUGIN_FILENAME: WideString = 'FileName';
  STR_PLUGIN_EXTENSION: WideString = 'Extension';
  STR_PLUGIN_PATH: WideString = 'Path';

  STR_DISABLE: WideString = 'Disable';
  STR_ENABLE: WideString = 'Enable';

  STR_FOLDERSIZE: WideString = 'Folder Size';
  STR_LOADING: WideString = 'Loading...';

  STR_BREADCRUMBBAR: WideString = 'BreadCrumb Bar';

  STR_OPTIONSTREEVIEW: WideString = 'Treeview';
  STR_OPTIONSLISTVIEW: WideString = 'Listview';
  STR_OPTIONSLISTVIEWCOLUMN: WideString = 'Columns';
  STR_OPTIONSLISTVIEWCOLORING: WideString = 'Coloring';
  STR_OPTIONSLISTVIEWGROUP: WideString = 'Grouping';
  STR_OPTIONSLISTVIEWTHUMBNAILS: WideString = 'Thumbnails';
  STR_OPTIONSHISTORY: WideString = 'History';
  STR_OPTIONSFAVORITES: WideString = 'Favorites';
  STR_OPTIONSFILTER: WideString = 'Filter';
  STR_OPTIONSCMDLINE: WideString = 'Command Line';
  STR_OPTIONSDROPSTACK: WideString = 'Drop Stack';
  STR_OPTIONSVIEWER: WideString = 'Viewer';
  STR_OPTIONSTOOLBAR: WideString = 'Toolbars';
  STR_OPTIONSTOOLBARDRIVE: WideString = 'Drives';
  STR_OPTIONSFOLDERSIZES: WideString = 'Folder Size';
  STR_OPTIONSTABS: WideString = 'Tabs';
  STR_OPTIONSGENERAL: WideString = 'General';
  STR_OPTIONSMOUSE: WideString = 'Mouse';
  STR_SEARCH_SEARCHFOR: WideString = 'Search for?';
  STR_SEARCH_SEARCHMODIFIED: WideString = 'When was it modified?';
  STR_SEARCH_SEARCHSIZE: WideString = 'What size is it?';
  STR_SEARCH_SEARCHADVANCED: WideString = 'More advanced options';
  STR_SEARCH_SEARCHFOLDERS: WideString = 'Select folder(s)';
  STR_SEARCH: WideString = 'Search';
  STR_EDIT_ELLIPSIS: WideString = 'Edit...';
  STR_PATH: WideString = 'Path';
  STR_CANNOTFINDFILE: WideString = 'Can not find the file';
  STR_DUPLICATE_GESTURE: WideString = 'Two or more Mouse Gestures are assigned the same value, please assign a unique value to each Mouse Gesture.';
  STR_DROPSTACKWARNING: WideString = 'Only references to the files are placed in the Drop Stack.  The original files MUST exist when the items in the Drop Stack are dragged out and placed in their target destination';
  STR_CORRUPT_CONFIG_FILE: WideString = 'The configuration file %FileName1% is corrupted. The file will be copied to %FileName2% and the original copy deleted.';
  STR_FALSE: WideString = 'False';
  STR_TRUE: WideString = 'True';
  STR_EXTENSION: WideString = 'Extension';
  STR_COLOR: WideString = 'Color';
  STR_BOLD: WideString = 'Bold'; 
  STR_ITALIC: WideString = 'Italic';
  STR_UNDERLINE: WideString = 'Underline';
  STR_SAMPLE: WideString = 'Sample';
  STR_SAMPLETEXT: WideString = '"This is sample Text"';
  STR_INVALID_COLOR: WideString = 'The color entered is not a valid value';

  FrameCaptions: TFrameCaptions;

  procedure ChangeLanguageStrings;
  procedure LoadOptionsTreeviewStrings;

implementation

{$R UltraExplorer.dkl_const.res}

// Update to add more nodes to the Options Treeview
procedure LoadOptionsTreeviewStrings;
begin
  FrameCaptions[0] := STR_OPTIONSTREEVIEW;
  FrameCaptions[1] := STR_OPTIONSLISTVIEW;
  FrameCaptions[2] := STR_OPTIONSLISTVIEWCOLORING;
  FrameCaptions[3] := STR_OPTIONSLISTVIEWCOLUMN;
  FrameCaptions[4] := STR_OPTIONSLISTVIEWGROUP;
  FrameCaptions[5] := STR_OPTIONSLISTVIEWTHUMBNAILS;
  FrameCaptions[6] := STR_OPTIONSHISTORY;
  FrameCaptions[7] := STR_OPTIONSFAVORITES;
  FrameCaptions[8] := STR_OPTIONSFILTER;
  FrameCaptions[9] := STR_OPTIONSCMDLINE;
  FrameCaptions[10] := STR_OPTIONSDROPSTACK;
  FrameCaptions[11] := STR_OPTIONSVIEWER;
  FrameCaptions[12] := STR_OPTIONSTOOLBAR;
  FrameCaptions[13] := STR_OPTIONSTOOLBARDRIVE;
  FrameCaptions[14] := STR_OPTIONSFOLDERSIZES;
  FrameCaptions[15] := STR_OPTIONSTABS;
  FrameCaptions[16] := STR_OPTIONSMOUSE;
  FrameCaptions[17] := STR_OPTIONSGENERAL;
end;

procedure ChangeLanguageStrings;
begin
  STR_ARCHIVE := DKLangConstW('STR_ARCHIVE');
  STR_COLUMNDLG_BUTTONCANCEL := DKLangConstW('STR_COLUMNDLG_BUTTONCANCEL');
  STR_COLUMNDLG_BUTTONOK := DKLangConstW('STR_COLUMNDLG_BUTTONOK');
  STR_COLUMNDLG_CAPTION := DKLangConstW('STR_COLUMNDLG_CAPTION');
  STR_COLUMNDLG_CHECKBOXLIVEUPDATE := DKLangConstW('STR_COLUMNDLG_CHECKBOXLIVEUPDATE');
  STR_COLUMNDLG_LABEL1 := DKLangConstW('STR_COLUMNDLG_LABEL1');
  STR_COLUMNDLG_LABEL2 := DKLangConstW('STR_COLUMNDLG_LABEL2');
  STR_COLUMNDLG_LABEL3 := DKLangConstW('STR_COLUMNDLG_LABEL3');
  STR_COLUMNMENU_MORE := DKLangConstW('STR_COLUMNMENU_MORE');
  STR_COMPRESS := DKLangConstW('STR_COMPRESS');
  STR_CONFIRM := DKLangConstW('STR_CONFIRM');
  STR_DRIVELETTER_A := DKLangConstW('STR_DRIVELETTER_A');
  STR_ERR_BAD_PIDL_RELATIONSHIP := DKLangConstW('STR_ERR_BAD_PIDL_RELATIONSHIP');
  STR_ERR_INVALID_CUSTOMPATH := DKLangConstW('STR_ERR_INVALID_CUSTOMPATH');
  STR_FAVORITES_CONTEXT_WARNING := DKLangConstW('STR_FAVORITES_CONTEXT_WARNING');
  STR_FAVORITES_DROP_WARNING := DKLangConstW('STR_FAVORITES_DROP_WARNING');
  STR_FILE := DKLangConstW('STR_FILE');
  STR_FILE_SIZE_IN_KB := DKLangConstW('STR_FILE_SIZE_IN_KB');
  STR_FILTER_FOLDERS := DKLangConstW('STR_FILTER_FOLDERS');
  STR_FTPNEWPROFILE := DKLangConstW('STR_FTPNEWPROFILE');
  STR_FTPPROFILESAVE := DKLangConstW('STR_FTPPROFILESAVE');
  STR_HEADERMENUMORE := DKLangConstW('STR_HEADERMENUMORE');
  STR_HIDDEN := DKLangConstW('STR_HIDDEN');
  STR_HISTORY_CONTEXT_WARNING := DKLangConstW('STR_HISTORY_CONTEXT_WARNING');
  STR_HISTORY_DROP_WARNING := DKLangConstW('STR_HISTORY_DROP_WARNING');
  STR_LANGUAGEHELPME := DKLangConstW('STR_LANGUAGEHELPME');
  STR_LOADINGPLUGIN := DKLangConstW('STR_LOADINGPLUGIN');
  STR_NOFILESELECTED := DKLangConstW('STR_NOFILESELECTED');
  STR_OBJECTS := DKLangConstW('STR_OBJECTS');
  STR_OBJECTS_SELECTED := DKLangConstW('STR_OBJECTS_SELECTED');
  STR_ONE_KB := DKLangConstW('STR_ONE_KB');
  STR_PROPERTIES := DKLangConstW('STR_PROPERTIES');
  STR_READONLY := DKLangConstW('STR_READONLY');
  STR_SYSTEM := DKLangConstW('STR_SYSTEM');
  STR_SYSTEMFOLDER := DKLangConstW('STR_SYSTEMFOLDER');
  STR_ULTRAEXPLORER := DKLangConstW('STR_ULTRAEXPLORER');
  STR_UNKNOWNCOMMAN := DKLangConstW('STR_UNKNOWNCOMMAN');
  STR_VIEWERCAPTION := DKLangConstW('STR_VIEWERCAPTION');
  STR_WARNING := DKLangConstW('STR_WARNING');
  STR_ZERO_KB := DKLangConstW('STR_ZERO_KB');
  S_COMBOEDIT_DEFAULT_ERROR1 := DKLangConstW('S_COMBOEDIT_DEFAULT_ERROR1');
  S_COMBOEDIT_DEFAULT_ERROR2 := DKLangConstW('S_COMBOEDIT_DEFAULT_ERROR2');
  STR_ERROR := DKLangConstW('STR_ERROR');
  S_FOLDER := DKLangConstW('S_FOLDER');
  S_NEW := DKLangConstW('S_NEW');
  STR_NOTARGETDEFINED := DKLangConstW('STR_NOTARGETDEFINED');
  S_OPEN := DKLangConstW('S_OPEN');
  S_OVERWRITE_EXISTING_FILE := DKLangConstW('S_OVERWRITE_EXISTING_FILE');
  S_PATH_ERROR := DKLangConstW('S_PATH_ERROR');
  S_SHORTCUT := DKLangConstW('S_SHORTCUT');
  S_WARNING := DKLangConstW('S_WARNING');
  STR_GROUPMODIFIEDTODAY := DKLangConstW('STR_GROUPMODIFIEDTODAY');
  STR_GROUPMODIFIEDTHISWEEK := DKLangConstW('STR_GROUPMODIFIEDTHISWEEK');
  STR_GROUPMODIFIEDTWOWEEKS := DKLangConstW('STR_GROUPMODIFIEDTWOWEEKS');
  STR_GROUPMODIFIEDTHREEWEEKS := DKLangConstW('STR_GROUPMODIFIEDTHREEWEEKS');
  STR_GROUPMODIFIEDMONTH := DKLangConstW('STR_GROUPMODIFIEDMONTH');
  STR_GROUPMODIFIEDTWOMONTHS := DKLangConstW('STR_GROUPMODIFIEDTWOMONTHS');
  STR_GROUPMODIFIEDTHREEMONTHS := DKLangConstW('STR_GROUPMODIFIEDTHREEMONTHS');
  STR_GROUPMODIFIEDFOURMONTHS := DKLangConstW('STR_GROUPMODIFIEDFOURMONTHS');
  STR_GROUPMODIFIEDFIVEMONTHS := DKLangConstW('STR_GROUPMODIFIEDFIVEMONTHS');
  STR_GROUPMODIFIEDSIXMONTHS := DKLangConstW('STR_GROUPMODIFIEDSIXMONTHS');
  STR_GROUPMODIFIEDEARLIERTHISYEAR := DKLangConstW('STR_GROUPMODIFIEDEARLIERTHISYEAR');
  STR_GROUPMODIFIEDLONGTIMEAGO := DKLangConstW('STR_GROUPMODIFIEDLONGTIMEAGO');
  STR_GROUPSIZEZERO := DKLangConstW('STR_GROUPSIZEZERO');
  STR_GROUPSIZETINY := DKLangConstW('STR_GROUPSIZETINY');
  STR_GROUPSIZESMALL := DKLangConstW('STR_GROUPSIZESMALL');
  STR_GROUPSIZEMEDIUM := DKLangConstW('STR_GROUPSIZEMEDIUM');
  STR_GROUPSIZELARGE := DKLangConstW('STR_GROUPSIZELARGE');
  STR_GROUPSIZEGIGANTIC := DKLangConstW('STR_GROUPSIZEGIGANTIC');
  STR_GROUPSIZESYSFOLDER := DKLangConstW('STR_GROUPSIZESYSFOLDER');
  STR_GROUPSIZEFOLDER := DKLangConstW('STR_GROUPSIZEFOLDER');
  STR_GROUPINGEDITFILESIZE := DKLangConstW('STR_GROUPINGEDITFILESIZE');
  STR_GROUPINGEDITMODIFIEDNEW := DKLangConstW('STR_GROUPINGEDITMODIFIEDNEW');
  STR_GROUPINGEDITMODIFIEDDATE := DKLangConstW('STR_GROUPINGEDITMODIFIEDDATE');
  STR_GROUPINGFOLDEROBJECTS := DKLangConstW('STR_GROUPINGFOLDEROBJECTS');
  STR_GROUPINGSPECIALFOLDEROBJECTS := DKLangConstW('STR_GROUPINGSPECIALFOLDEROBJECTS');
  STR_CAPTION := DKLangConstW('STR_CAPTION');
  STR_FILESIZE := DKLangConstW('STR_CAPTION');
  STR_MODIFYDATE := DKLangConstW('STR_MODIFYDATE');

  STR_VIEW := DKLangConstW('STR_VIEW');
  STR_ICONVIEW := DKLangConstW('STR_ICONVIEW');
  STR_LISTVIEW := DKLangConstW('STR_LISTVIEW');
  STR_DETAILSVIEW := DKLangConstW('STR_DETAILSVIEW');
  STR_TILEVIEW := DKLangConstW('STR_TILEVIEW');
  STR_THUMBNAILVIEW := DKLangConstW('STR_THUMBNAILVIEW');
  STR_ARRANGE_NAME := DKLangConstW('STR_ARRANGE_NAME');
  STR_ARRANGE_SIZE := DKLangConstW('STR_ARRANGE_SIZE');
  STR_ARRANGE_TYPE := DKLangConstW('STR_ARRANGE_TYPE');
  STR_ARRANGE_MODIFIED := DKLangConstW('STR_ARRANGE_MODIFIED');
  STR_ARRANGE_GROUPS := DKLangConstW('STR_ARRANGE_GROUPS');
  STR_SELECTED := DKLangConstW('STR_SELECTED');
  STR_AUTOUPDATE_AVAILABLEPOST := DKLangConstW('STR_AUTOUPDATE_AVAILABLEPOST');
  STR_AUTOUPDATE_NOTAVAILABLE := DKLangConstW('STR_AUTOUPDATE_NOTAVAILABLE');
  STR_AUTOUPDATE_CONNECTFAILED := DKLangConstW('STR_AUTOUPDATE_CONNECTFAILED');
  STR_FILTEROUT := DKLangConstW('STR_FILTEROUT');
  STR_FILTERIN := DKLangConstW('STR_FILTERIN');
  STR_FREESPACE := DKLangConstW('STR_FREESPACE');
  STR_DRIVE := DKLangConstW('STR_DRIVE');
  STR_SIZE := DKLangConstW('STR_SIZE');
  STR_CHOOSEWORKINGDIR := DKLangConstW('STR_CHOOSEWORKINGDIR');
  STR_COPY_TO_DROPSTACK := DKLangConstW('STR_COPY_TO_DROPSTACK');  
  STR_PLUGIN_FILENAME := DKLangConstW('STR_PLUGIN_FILENAME');
  STR_PLUGIN_EXTENSION := DKLangConstW('STR_PLUGIN_EXTENSION');
  STR_PLUGIN_PATH := DKLangConstW('STR_PLUGIN_PATH');
  STR_DISABLE := DKLangConstW('STR_DISABLE');
  STR_ENABLE := DKLangConstW('STR_ENABLE');
  STR_FOLDERSIZE := DKLangConstW('STR_FOLDERSIZE');
  STR_LOADING := DKLangConstW('STR_LOADING');  
  STR_OPTIONSTREEVIEW := DKLangConstW('STR_OPTIONSTREEVIEW');
  STR_OPTIONSLISTVIEW := DKLangConstW('STR_OPTIONSLISTVIEW');
  STR_OPTIONSLISTVIEWCOLORING := DKLangConstW('STR_OPTIONSLISTVIEWCOLORING');
  STR_OPTIONSLISTVIEWCOLUMN := DKLangConstW('STR_OPTIONSLISTVIEWCOLUMN');
  STR_OPTIONSLISTVIEWGROUP := DKLangConstW('STR_OPTIONSLISTVIEWGROUP');
  STR_OPTIONSLISTVIEWTHUMBNAILS := DKLangConstW('STR_OPTIONSLISTVIEWTHUMBNAILS');
  STR_OPTIONSHISTORY := DKLangConstW('STR_OPTIONSHISTORY');
  STR_OPTIONSFAVORITES := DKLangConstW('STR_OPTIONSFAVORITES');
  STR_OPTIONSFILTER := DKLangConstW('STR_OPTIONSFILTER');
  STR_OPTIONSCMDLINE := DKLangConstW('STR_OPTIONSCMDLINE');
  STR_OPTIONSDROPSTACK := DKLangConstW('STR_OPTIONSDROPSTACK');
  STR_OPTIONSVIEWER := DKLangConstW('STR_OPTIONSVIEWER');
  STR_OPTIONSTOOLBAR := DKLangConstW('STR_OPTIONSTOOLBAR');
  STR_OPTIONSTOOLBARDRIVE := DKLangConstW('STR_OPTIONSTOOLBARDRIVE');
  STR_OPTIONSFOLDERSIZES := DKLangConstW('STR_OPTIONSFOLDERSIZES');
  STR_OPTIONSTABS := DKLangConstW('STR_OPTIONSTABS');
  STR_OPTIONSGENERAL := DKLangConstW('STR_OPTIONSGENERAL');
  STR_OPTIONSMOUSE := DKLangConstW('STR_OPTIONSMOUSE');
  STR_BREADCRUMBBAR := DKLangConstW('STR_BREADCRUMBBAR');
  STR_SEARCH_SEARCHFOR := DKLangConstW('STR_SEARCH_SEARCHFOR');
  STR_SEARCH_SEARCHMODIFIED := DKLangConstW('STR_SEARCH_SEARCHMODIFIED');
  STR_SEARCH_SEARCHSIZE := DKLangConstW('STR_SEARCH_SEARCHSIZE');
  STR_SEARCH_SEARCHADVANCED := DKLangConstW('STR_SEARCH_SEARCHADVANCED');
  STR_SEARCH_SEARCHFOLDERS := DKLangConstW('STR_SEARCH_SEARCHFOLDERS');
  STR_SEARCH := DKLangConstW('STR_SEARCH');
  STR_DUPLICATE_GESTURE := DKLangConstW('STR_DUPLICATE_GESTURE');
  STR_REMOVE_FAV_ITEM := DKLangConstW('STR_REMOVE_FAV_ITEM');
  STR_EDIT_ELLIPSIS := DKLangConstW('STR_EDIT_ELLIPSIS');
  STR_CANNOTFINDFILE := DKLangConstW('STR_CANNOTFINDFILE');
  STR_DROPSTACKWARNING := DKLangConstW('STR_DROPSTACKWARNING');
  STR_PATH := DKLangConstW('STR_PATH');
  STR_FALSE := DKLangConstW('STR_FALSE');
  STR_TRUE := DKLangConstW('STR_TRUE');
  STR_EXTENSION := DKLangConstW('STR_EXTENSION');
  STR_COLOR := DKLangConstW('STR_COLOR');
  STR_BOLD := DKLangConstW('STR_BOLD');
  STR_ITALIC := DKLangConstW('STR_ITALIC');
  STR_UNDERLINE := DKLangConstW('STR_UNDERLINE');
  STR_SAMPLE := DKLangConstW('STR_SAMPLE');
  STR_SAMPLETEXT := DKLangConstW('STR_SAMPLETEXT');
  STR_INVALID_COLOR := DKLangConstW('STR_INVALID_COLOR');

    // Added to DK Project Constants to here.........................



  LoadOptionsTreeviewStrings;
end;

end.
