unit UnitFTPConnectForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TntForms, SpTBXControls, StdCtrls, SpTBXEditors, 
  MPCommonObjects, EasyListview, UltraUserStrings, UnitFTPTree, MPCommonUtilities,
  TntSysUtils, DKLang, SpTBXItem;

type
  TTntFormFTPConnect = class(TTntForm)
    SpTBXPanel1: TSpTBXPanel;
    EasyListviewProfiles: TEasyListview;
    SpTBXLabel1: TSpTBXLabel;
    SpTBXLabel2: TSpTBXLabel;
    SpTBXLabel3: TSpTBXLabel;
    SpTBXLabel4: TSpTBXLabel;
    SpTBXLabel5: TSpTBXLabel;
    SpTBXLabel6: TSpTBXLabel;
    SpTBXLabel7: TSpTBXLabel;
    SpTBXLabel8: TSpTBXLabel;
    SpTBXLabel9: TSpTBXLabel;
    SpTBXEditProfile: TSpTBXEdit;
    SpTBXEditHost: TSpTBXEdit;
    SpTBXEditPort: TSpTBXEdit;
    SpTBXEditLogin: TSpTBXEdit;
    SpTBXEditPassword: TSpTBXEdit;
    SpTBXEditInitalPath: TSpTBXEdit;
    SpTBXEditAttempts: TSpTBXEdit;
    SpTBXEditRetryDelay: TSpTBXEdit;
    SpTBXEditDescription: TSpTBXEdit;
    SpTBXButtonAdd: TSpTBXButton;
    SpTBXButtonSave: TSpTBXButton;
    SpTBXButtonCancel: TSpTBXButton;
    SpTBXCheckBoxAnonymous: TSpTBXCheckBox;
    SpTBXButtonConnect: TSpTBXButton;
    SpTBXButtonOk: TSpTBXButton;
    SpTBXButtonDelete: TSpTBXButton;
    DKLanguageControllerFTP: TDKLanguageController;
    procedure SpTBXButtonAddClick(Sender: TObject);
    procedure SpTBXEditProfileExit(Sender: TObject);
    procedure SpTBXCheckBoxAnonymousClick(Sender: TObject);
    procedure TntFormShow(Sender: TObject);
    procedure SpTBXEditIsDirtyChange(Sender: TObject);
    procedure SpTBXButtonConnectClick(Sender: TObject);
    procedure SpTBXButtonOkClick(Sender: TObject);
    procedure SpTBXButtonSaveClick(Sender: TObject);
    procedure SpTBXEditNumberOnlyKeyPress(Sender: TObject; var Key: Char);
    procedure SpTBXButtonDeleteClick(Sender: TObject);
    procedure EasyListviewProfilesItemFreeing(Sender: TCustomEasyListview; Item: TEasyItem);
    procedure TntFormClose(Sender: TObject; var Action: TCloseAction);
    procedure EasyListviewProfilesItemSelectionChanged(Sender: TCustomEasyListview; Item: TEasyItem);
    procedure EasyListviewProfilesItemSelectionChanging(Sender: TCustomEasyListview; Item: TEasyItem; var Allow: Boolean);
    procedure TntFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    FConnection: TEasyFTPConnection;
    FIsDirty: Boolean;
    procedure SetIsDirty(const Value: Boolean);
  protected
    function QuerySave: Boolean;
    procedure EnableConnectionInput(Enable: Boolean);
    procedure SaveCurrentConnection;
    procedure SaveProfiles;
    property IsDirty: Boolean read FIsDirty write SetIsDirty;
  public
    { Public declarations }
    property Connection: TEasyFTPConnection read FConnection write FConnection;
  end;

implementation

{$R *.DFM}

uses
  UnitYesNoDialog;

function TTntFormFTPConnect.QuerySave: Boolean;
var
  TntFormYesNoDialog: TTntFormYesNoDialog;
begin
  Result := False;
  TntFormYesNoDialog := TTntFormYesNoDialog.CreateEx(Self);
  try
    TntFormYesNoDialog.SpTBXLabel.Caption := STR_FTPPROFILESAVE;
    TntFormYesNoDialog.Caption := STR_CONFIRM;
    if TntFormYesNoDialog.ShowModal = mrYes then
      Result := True;
  finally
    TntFormYesNoDialog.Release
  end

end;

procedure TTntFormFTPConnect.EnableConnectionInput(Enable: Boolean);
begin
  SpTBXEditProfile.Enabled := Enable;
  SpTBXEditHost.Enabled := Enable;
  SpTBXEditPort.Enabled := Enable;
  SpTBXEditLogin.Enabled := Enable;
  SpTBXEditPassword.Enabled := Enable;
  SpTBXCheckBoxAnonymous.Enabled := Enable;
  SpTBXEditInitalPath.Enabled := Enable;
  SpTBXEditAttempts.Enabled := Enable;
  SpTBXEditRetryDelay.Enabled := Enable;
  SpTBXEditDescription.Enabled := Enable;
end;

procedure TTntFormFTPConnect.SaveCurrentConnection;
var
  Connect: TEasyFTPConnection;
  Item: TEasyItem;
begin
  Item := EasyListviewProfiles.Selection.First;
  if Assigned(Item) then
  begin
    Connect := TEasyFTPConnection(Item.Data);
    Connect.Profile := SpTBXEditProfile.Text;
    Connect.Port := StrToInt(SpTBXEditPort.Text);
    Connect.Host := SpTBXEditHost.Text;
    Connect.Description := SpTBXEditDescription.Text;
    Connect.Password := SpTBXEditPassword.Text;
    Connect.UserName := SpTBXEditLogin.Text;
    Connect.InitalPath := SpTBXEditInitalPath.Text;
    Connect.RetryDelay := StrToInt(SpTBXEditRetryDelay.Text);
    Connect.Attempts := StrToInt(SpTBXEditAttempts.Text);
  end;
  IsDirty := False;
end;

procedure TTntFormFTPConnect.SaveProfiles;
var
  i: Integer;
  Connect: TEasyFTPConnection;
begin
  FTPConnections.Items.Clear;
  for i := 0 to EasyListviewProfiles.Items.Count - 1 do
  begin
    Connect := FTPConnections.Items.Add;
    Connect.Assign(TEasyFTPConnection( EasyListviewProfiles.Items[i].Data))
  end
end;

procedure TTntFormFTPConnect.SetIsDirty(const Value: Boolean);
begin
  FIsDirty := Value;
  SpTBXButtonSave.Enabled := Value
end;

procedure TTntFormFTPConnect.SpTBXButtonAddClick(Sender: TObject);
var
  Item: TEasyItem;
  Connect: TEasyFTPConnection;
begin
  Connect := TEasyFTPConnection.Create(nil);
  Item := EasyListviewProfiles.Items.Add(Connect);
  Item.Selected := True;
  Item.Caption := STR_FTPNEWPROFILE;
  Connect.Profile := STR_FTPNEWPROFILE;
  Connect.Port := 21;
  Connect.RetryDelay := 10;
  Connect.Attempts := 5;
  SpTBXEditProfile.Text := STR_FTPNEWPROFILE;
  SpTBXEditAttempts.Text := IntToStr(Connect.Attempts);
  SpTBXEditRetryDelay.Text := IntToStr(Connect.RetryDelay);
  SpTBXEditPort.Text := IntToStr(Connect.Port);
  SpTBXEditProfile.SetFocus;
  SpTBXEditProfile.SelectAll;
  Item.ImageIndex := 0;
end;

procedure TTntFormFTPConnect.SpTBXEditProfileExit(Sender: TObject);
begin
  if EasyListviewProfiles.Selection.First <> nil then
    EasyListviewProfiles.Selection.First.Caption := SpTBXEditProfile.Text;
end;

procedure TTntFormFTPConnect.SpTBXCheckBoxAnonymousClick(Sender: TObject);
begin
  if SpTBXCheckBoxAnonymous.Checked then
    SpTBXEditPassword.Text := 'anonymous'
  else
    SpTBXEditPassword.Text := ''
end;

procedure TTntFormFTPConnect.TntFormShow(Sender: TObject);
var
  i: Integer;
  Item: TEasyItem;
  Connect: TEasyFTPConnection;
begin
  FixFormFont(Font);
  EnableConnectionInput(False);
  Connection := TEasyFTPConnection.Create(nil);
  for i := 0 to FTPConnections.Items.Count - 1 do
  begin
    Connect := TEasyFTPConnection.Create(nil);
    Connect.Assign(FTPConnections.Items[i]);
    Item := EasyListviewProfiles.Items.Add(Connect);
    Item.Caption := Connect.Profile
  end;
  if EasyListviewProfiles.Items.Count > 0 then
  begin
    EasyListviewProfiles.Items[0].Selected := True;
    EasyListviewProfiles.Items[0].Focused := True;
  end;
  IsDirty := False;
end;

procedure TTntFormFTPConnect.SpTBXEditIsDirtyChange(Sender: TObject);
begin
  IsDirty := True
end;

procedure TTntFormFTPConnect.SpTBXButtonConnectClick(Sender: TObject);
var
  Item: TEasyItem;
begin
  if IsDirty and QuerySave then
    SaveCurrentConnection;
  SaveProfiles;
  Item := EasyListviewProfiles.Selection.First;
  if Assigned(Item) then
    Connection.Assign(TEasyFTPConnection( Item.Data));
end;

procedure TTntFormFTPConnect.SpTBXButtonOkClick(Sender: TObject);
begin
  if IsDirty and QuerySave then
    SaveCurrentConnection;
  SaveProfiles;
end;

procedure TTntFormFTPConnect.SpTBXButtonSaveClick(Sender: TObject);
begin
  SaveCurrentConnection;
end;

procedure TTntFormFTPConnect.SpTBXEditNumberOnlyKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not(((Key > '0') and (Key < '9')) or (Key = #13)) then
  begin
    Key := #0;
    beep
  end
end;

procedure TTntFormFTPConnect.SpTBXButtonDeleteClick(Sender: TObject);
var
  Item: TEasyItem;
  Index: Integer;
begin
  Item := EasyListviewProfiles.Selection.First;
  Index := Item.Index;
  if Assigned(Item) then
    EasyListviewProfiles.Selection.DeleteSelected;
  if Index >= EasyListviewProfiles.Items.Count then
    Index := EasyListviewProfiles.Items.Count - 1;
  if Index > -1 then
  begin
    EasyListviewProfiles.Items[Index].Selected := True;
    EasyListviewProfiles.Items[Index].Focused := True;
  end
end;

procedure TTntFormFTPConnect.EasyListviewProfilesItemFreeing(
  Sender: TCustomEasyListview; Item: TEasyItem);
begin
  if Assigned(Item) then
    TObject(Item.Data).Free
end;

procedure TTntFormFTPConnect.TntFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  EasyListviewProfiles.Selection.ClearAll;
  EasyListviewProfiles.Selection.FocusedItem := nil;
end;

procedure TTntFormFTPConnect.EasyListviewProfilesItemSelectionChanged(
  Sender: TCustomEasyListview; Item: TEasyItem);
var
  Connect: TEasyFTPConnection;
begin
  SpTBXButtonDelete.Enabled := EasyListviewProfiles.Selection.Count > 0;
  SpTBXButtonDelete.Enabled := EasyListviewProfiles.Selection.Count > 0;
  SpTBXButtonConnect.Enabled := (EasyListviewProfiles.Selection.Count = 1);
  if Assigned(Item) and (EasyListviewProfiles.Selection.Count > 0) then
  begin
    EnableConnectionInput(True);
    Connect := TEasyFTPConnection( Item.Data);
    SpTBXEditProfile.Text := Connect.Profile;
    SpTBXEditHost.Text := Connect.Host;
    SpTBXEditPort.Text := IntToStr(Connect.Port);
    SpTBXEditLogin.Text := Connect.UserName;
    SpTBXEditPassword.Text := Connect.Password;
    SpTBXCheckBoxAnonymous.Checked := Tnt_WideUpperCase(Connect.Password) = 'anonymous';
    SpTBXEditInitalPath.Text := Connect.InitalPath;
    SpTBXEditAttempts.Text := IntToStr(Connect.Attempts);
    SpTBXEditRetryDelay.Text := IntToStr(Connect.RetryDelay);
    SpTBXEditDescription.Text := Connect.Description;
  end else
  begin
    EnableConnectionInput(False);
    SpTBXEditProfile.Text := '';
    SpTBXEditHost.Text := '';
    SpTBXEditPort.Text := '';
    SpTBXEditLogin.Text := '';
    SpTBXEditPassword.Text := '';
    SpTBXCheckBoxAnonymous.Checked := False;
    SpTBXEditInitalPath.Text := '';
    SpTBXEditAttempts.Text := '';
    SpTBXEditRetryDelay.Text := '';
    SpTBXEditDescription.Text := '';
  end;
  IsDirty := False;
end;

procedure TTntFormFTPConnect.EasyListviewProfilesItemSelectionChanging(
  Sender: TCustomEasyListview; Item: TEasyItem; var Allow: Boolean);
begin
  if IsDirty and QuerySave then
    SaveCurrentConnection;
end;

procedure TTntFormFTPConnect.TntFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Close
end;

end.
