unit UnitHelpTranslateForm;

// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you maynot use this file except in compliance
// with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
//
// Alternatively, you may redistribute this library, use and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software Foundation;
// either version 2.1 of the License, or (at your option) any later version.
// You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
// specific language governing rights and limitations under the License.

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TntForms, SpTBXControls, StdCtrls, TntStdCtrls,
  TntSysUtils, TntClasses, MPCommonUtilities, UltraUserStrings, ShellAPI,
  jpeg, ExtCtrls, DKLang, SpTBXItem;

type
  TTntFormTranslation = class(TTntForm)
    SpTBXPanel1: TSpTBXPanel;
    Image1: TImage;
    SpTBXButtonOk: TSpTBXButton;
    SpTBXLabel1: TSpTBXLabel;
    SpTBXLabel2: TSpTBXLabel;
    SpTBXButtonWebSite: TSpTBXButton;
    SpTBXButtonInstruction: TSpTBXButton;
    DKLanguageControllerTranslation: TDKLanguageController;
    procedure TBXLink1Click(Sender: TObject);
    procedure SpTBXButtonWebSiteClick(Sender: TObject);
    procedure SpTBXButtonInstructionClick(Sender: TObject);
    procedure TntFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TntFormShow(Sender: TObject);
  private
    { Private declarations }
    FWndParent: HWnd;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    property WndParent: HWnd read FWndParent write FWndParent;
  public
    { Public declarations }
    constructor CreateEx(AnOwner: TCustomForm);
  end;

implementation

{$R *.DFM}

constructor TTntFormTranslation.CreateEx(AnOwner: TCustomForm);
begin
  if Assigned(AnOwner) then
     WndParent := AnOwner.Handle
   else
     WndParent := 0;
   inherited Create(nil);
end;

procedure TTntFormTranslation.CreateParams(var Params: TCreateParams);
begin
  inherited;
  if WndParent <> 0 then
    Params.WndParent := WndParent;
end;

procedure TTntFormTranslation.TBXLink1Click(Sender: TObject);
begin
  WideShellExecute(Handle, 'open', ModuleFileName + STR_HELPLANGUAGETRANSLATE, '', '', SW_NORMAL);
end;

procedure TTntFormTranslation.SpTBXButtonWebSiteClick(Sender: TObject);
begin
  WideShellExecute(Handle, 'open', STR_URL_DKLANG, '', '', SW_NORMAL);
end;

procedure TTntFormTranslation.SpTBXButtonInstructionClick(Sender: TObject);
begin
  WideShellExecute(Handle, 'open', ModuleFileName + STR_URL_DKLANG_INSTRUCTIONS, '', '', SW_NORMAL);
end;

procedure TTntFormTranslation.TntFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Close
end;

procedure TTntFormTranslation.TntFormShow(Sender: TObject);
begin
  FixFormFont(Font);
  if SpTBXButtonOk.Top + SpTBXButtonOk.Height > ClientHeight then
   ClientHeight := SpTBXButtonOk.Top + SpTBXButtonOk.Height + 8
end;

end.
