unit UnitListerPluginsExtensionsForm;

// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you maynot use this file except in compliance
// with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
//
// Alternatively, you may redistribute this library, use and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software Foundation;
// either version 2.1 of the License, or (at your option) any later version.
// You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
// specific language governing rights and limitations under the License.

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  TntForms,
  SpTBXDkPanels,
  SpTBXControls,
  StdCtrls,
  SpTBXEditors,
  WLXProc,
  DKLang,
  MPCommonUtilities, SpTBXItem;

type
  TTntFormExtEdit = class(TTntForm)
    SpTBXPanel1: TSpTBXPanel;
    SpTBXEditExt: TSpTBXEdit;
    SpTBXButtonOk: TSpTBXButton;
    SpTBXButtonCancel: TSpTBXButton;
    SpTBXLabel1: TSpTBXLabel;
    SpTBXLabel2: TSpTBXLabel;
    SpTBXButtonDefault: TSpTBXButton;
    DKLanguageControllerPluginExtEditor: TDKLanguageController;
    procedure SpTBXButtonDefaultClick(Sender: TObject);
    procedure TntFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TntFormShow(Sender: TObject);
    procedure TntFormCreate(Sender: TObject);
  private
    FPluginPath: WideString;
    FWndParent: HWnd;
    { Private declarations }
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    property WndParent: HWnd read FWndParent write FWndParent;
  public
    { Public declarations }
    constructor CreateEx(AnOwner: TCustomForm);

    property PluginPath: WideString read FPluginPath write FPluginPath;
  end;

implementation

{$R *.DFM}

constructor TTntFormExtEdit.CreateEx(AnOwner: TCustomForm);
begin
  if Assigned(AnOwner) then
     WndParent := AnOwner.Handle
   else
     WndParent := 0;
   inherited Create(nil);
end;

procedure TTntFormExtEdit.CreateParams(var Params: TCreateParams);
begin
  inherited;
  if WndParent <> 0 then
    Params.WndParent := WndParent;
end;

procedure TTntFormExtEdit.SpTBXButtonDefaultClick(Sender: TObject);
begin
  SpTBXEditExt.Text := WlxGetDetectString(PluginPath);
end;

procedure TTntFormExtEdit.TntFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Close
end;

procedure TTntFormExtEdit.TntFormShow(Sender: TObject);
begin
  FixFormFont(Font);
  ClientWidth := SpTBXPanel1.Width + 8;
  ClientHeight := SpTBXPanel1.Height + 8;
  if SpTBXButtonOk.Top + SpTBXButtonOk.Height > ClientHeight then
   ClientHeight := SpTBXButtonOk.Top + SpTBXButtonOk.Height + 8
end;

procedure TTntFormExtEdit.TntFormCreate(Sender: TObject);
begin
  BorderStyle := bsSizeable;
end;

end.
