unit UnitOptionsBase;

// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you maynot use this file except in compliance
// with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
//
// Alternatively, you may redistribute this library, use and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software Foundation;
// either version 2.1 of the License, or (at your option) any later version.
// You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
// specific language governing rights and limitations under the License.

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  TntForms,
  UltraOptions,
  SpTBXItem,
  TntDialogs,
  MPCommonUtilities;

type
  TTntOptionsBaseForm = class(TTntForm)
  protected
    FSpTBXDockHeader: TSpTBXDock;
    FSpTBXToolbar: TSpTBXToolbar;
    FTempColor: TColor;
    FColorDialog: TColorDialog;
    FTempFont: TFont;
    FFontDialog: TFontDialog;
    FIsDirty: TIsDirtyProc;
    FLockAllColors: TLockAllColorsProc;
    FLockAllFonts: TLockAllFontsProc;
    FQueryModifyColor: TQueryModifyColorProc;
    FQueryModifyFont: TQueryModifyFontProc;
    FSetAllWindowColors: TSetAllWindowColorsProc;
    FSetAllWindowFonts: TSetAllWindowFontsProc;
    FTntOpenDialog: TTntOpenDialog;
    { Private declarations }
    procedure DoShow; override;
  public
    procedure Dirty(SetDirty: Boolean);

    property ColorDialog: TColorDialog read FColorDialog write FColorDialog;
    property FontDialog: TFontDialog read FFontDialog write FFontDialog;
    property IsDirty: TIsDirtyProc read FIsDirty write FIsDirty;
    property LockAllColors: TLockAllColorsProc read FLockAllColors write FLockAllColors;
    property LockAllFonts: TLockAllFontsProc read FLockAllFonts write FLockAllFonts;
    property QueryModifyColor: TQueryModifyColorProc read FQueryModifyColor write FQueryModifyColor;
    property QueryModifyFont: TQueryModifyFontProc read FQueryModifyFont write FQueryModifyFont;
    property SetAllWindowColors: TSetAllWindowColorsProc read FSetAllWindowColors write FSetAllWindowColors;
    property SetAllWindowFonts: TSetAllWindowFontsProc read FSetAllWindowFonts write FSetAllWindowFonts;
    property TempColor: TColor read FTempColor write FTempColor;
    property TempFont: TFont read FTempFont write FTempFont;
    property TntOpenDialog: TTntOpenDialog read FTntOpenDialog write FTntOpenDialog;
    property SpTBXDockHeader: TSpTBXDock read FSpTBXDockHeader write FSpTBXDockHeader;
    property SpTBXToolbar: TSpTBXToolbar read FSpTBXToolbar write FSpTBXToolbar;
  end;

var
  TntOptionsBaseForm: TTntOptionsBaseForm;

implementation

{$R *.DFM}

{ TTntOptionsBaseForm }

procedure TTntOptionsBaseForm.Dirty(SetDirty: Boolean);
begin
  if Assigned(IsDirty) then
    IsDirty(SetDirty)
end;

procedure TTntOptionsBaseForm.DoShow;
begin
  inherited DoShow;
  FixFormFont(Font)
end;

end.

