unit UnitOptionsCmdLine;

// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you maynot use this file except in compliance
// with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
//
// Alternatively, you may redistribute this library, use and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software Foundation;
// either version 2.1 of the License, or (at your option) any later version.
// You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
// specific language governing rights and limitations under the License.

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  TntForms,
  SpTBXControls,
  StdCtrls,
  SpTBXEditors,
  SpTBXDkPanels,
  UltraOptions,
  UnitOptionsBase,
  UltraUserStrings,
  DKLang, SpTBXItem;

type
  TTntFormOptionsCmdLine = class(TTntOptionsBaseForm)
    SpTBXPanel1: TSpTBXPanel;
    SpTBXGroupBoxCmdLineColorFont: TSpTBXGroupBox;
    SpTBXButtonCmdLineWndColor: TSpTBXButton;
    SpTBXButtonCmdLineFont: TSpTBXButton;
    SpTBXEditCmdLineSample: TSpTBXEdit;
    SpTBXGroupBoxCmdLineGeneral: TSpTBXGroupBox;
    SpTBXLabel1: TSpTBXLabel;
    SpTBXEditOptionsCmdLineDepth: TSpTBXEdit;
    SpTBXCheckBoxCmdLineSync: TSpTBXCheckBox;
    DKLanguageController1: TDKLanguageController;
    procedure SpTBXButtonCmdLineWndColorClick(Sender: TObject);
    procedure SpTBXButtonCmdLineFontClick(Sender: TObject);
    procedure SpTBXEditOptionsCmdLineDepthKeyPress(Sender: TObject;
      var Key: Char);
    procedure IsDirtyClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

type
  TCmdLineAttribsHack = class(TCmdLineAttribs);

procedure TTntFormOptionsCmdLine.SpTBXButtonCmdLineWndColorClick(Sender: TObject);
begin
  TempColor := TCmdLineAttribsHack( Attribs.CmdLine).FColor;
  if QueryModifyColor(FTempColor) then
  begin
    SpTBXEditCmdLineSample.Color := TempColor;
    Dirty(True)
  end
end;

procedure TTntFormOptionsCmdLine.SpTBXButtonCmdLineFontClick(Sender: TObject);
begin
  TempFont.Assign(Attribs.CmdLine.Font);
  if QueryModifyFont(TempFont) then
  begin
    Attribs.CmdLine.Font.Assign(TempFont);
    SpTBXEditCmdLineSample.Font.Assign(Attribs.CmdLine.Font);
    Dirty(True)
  end
end;

procedure TTntFormOptionsCmdLine.SpTBXEditOptionsCmdLineDepthKeyPress(
  Sender: TObject; var Key: Char);
begin
  if not (Key in NUMERIC_KEYS) then
    Key := #0;
  Dirty(True)
end;

procedure TTntFormOptionsCmdLine.IsDirtyClick(Sender: TObject);
begin
  Dirty(True)
end;


procedure TTntFormOptionsCmdLine.FormShow(Sender: TObject);
begin
  ClientWidth := SpTBXPanel1.Width;
  ClientHeight := SpTBXPanel1.Height;
end;

end.
