unit UnitOptionsDropStack;

// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you maynot use this file except in compliance
// with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
//
// Alternatively, you may redistribute this library, use and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software Foundation;
// either version 2.1 of the License, or (at your option) any later version.
// You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
// specific language governing rights and limitations under the License.

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  TntForms,
  SpTBXControls,
  StdCtrls,
  SpTBXEditors,
  SpTBXDkPanels,
  UltraUserStrings,
  UnitOptionsBase,
  DKLang, SpTBXItem;

type
  TTntFormOptionsDropStack = class(TTntOptionsBaseForm)
    SpTBXPanel1: TSpTBXPanel;
    SpTBXGroupBoxDropStackColorFont: TSpTBXGroupBox;
    SpTBXButtonDropStackColor: TSpTBXButton;
    SpTBXButtonDropStackFont: TSpTBXButton;
    SpTBXEditDropStackSample: TSpTBXEdit;
    SpTBXGroupBoxDropStackGeneral: TSpTBXGroupBox;
    SpTBXEditDropStackHintFiles: TSpTBXEdit;
    SpTBXLabelDropStackFileInHint: TSpTBXLabel;
    SpTBXEditDropStackDepth: TSpTBXEdit;
    SpTBXLabel2: TSpTBXLabel;
    SpTBXCheckBoxDropStackContentsHint: TSpTBXCheckBox;
    SpTBXRadioGroupDropStackAutoRemove: TSpTBXRadioGroup;
    DKLanguageController1: TDKLanguageController;
    procedure SpTBXButtonDropStackColorClick(Sender: TObject);
    procedure SpTBXButtonDropStackFontClick(Sender: TObject);
    procedure IsDirtyClick(Sender: TObject);
    procedure SpTBXEditDropStackEditKeyPress(Sender: TObject;
      var Key: Char);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TntFormOptionsDropStack: TTntFormOptionsDropStack;

implementation

{$R *.DFM}

procedure TTntFormOptionsDropStack.SpTBXButtonDropStackColorClick(
  Sender: TObject);
begin
  TempColor := SpTBXEditDropStackSample.Color;
  if QueryModifyColor(FTempColor) then
  begin
    if LockAllColors then
      SetAllWindowColors(ColorDialog.Color)
    else
      SpTBXEditDropStackSample.Color := ColorDialog.Color;
    Dirty(True);
  end
end;

procedure TTntFormOptionsDropStack.SpTBXButtonDropStackFontClick(
  Sender: TObject);
begin
  TempFont.Assign(SpTBXEditDropStackSample.Font);
  if QueryModifyFont(TempFont) then
  begin
    if LockAllFonts then
      SetAllWindowFonts(TempFont)
    else
      SpTBXEditDropStackSample.Font.Assign(TempFont);
    Dirty(True)
  end
end;

procedure TTntFormOptionsDropStack.IsDirtyClick(Sender: TObject);
begin
  Dirty(True)
end;

procedure TTntFormOptionsDropStack.SpTBXEditDropStackEditKeyPress(
  Sender: TObject; var Key: Char);
begin
  if not (Key in NUMERIC_KEYS) then
    Key := #0;
  Dirty(True)
end;

procedure TTntFormOptionsDropStack.FormShow(Sender: TObject);
begin
  ClientWidth := SpTBXPanel1.Width;
  ClientHeight := SpTBXPanel1.Height;
end;

end.
