unit UnitOptionsForm;

// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you maynot use this file except in compliance
// with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
//
// Alternatively, you may redistribute this library, use and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software Foundation;
// either version 2.1 of the License, or (at your option) any later version.
// You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
// specific language governing rights and limitations under the License.

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TB2Item, TBX, SpTBXItem, SpTBXTabs, StdCtrls, SpTBXEditors,
  TBXToolPals, SpTBXDkPanels, SpTBXControls,
  ActnList, TntActnList, ExtCtrls, ComCtrls, TntComCtrls, UltraOptions,
  TntDialogs, MPShellUtilities, ActiveX, ShlObj, UltraUtilities,
  TntSysUtils, ImgList, TntStdCtrls, EasyListview, DKLang,
  VirtualExplorerEasyListview, TntForms;

const
  STR_INVALID_INTEGER = 'Invalid integer format. Please enter a valid integer value';
  STR_ERROR = 'Error';
  NUMERIC_KEYS = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0'];
  FLOAT_KEYS = ['e', 'E', '-', '+', '.'];

type
  TTntFormUltraOptions = class(TTnTForm)
    SpTBXTabControlOptions: TSpTBXTabControl;
    SpTBXTabItem1: TSpTBXTabItem;
    SpTBXTabSheetTreeview: TSpTBXTabSheet;
    SpTBXTabItem2: TSpTBXTabItem;
    SpTBXTabSheetListview: TSpTBXTabSheet;
    SpTBXTabItem3: TSpTBXTabItem;
    SpTBXTabSheetGeneral: TSpTBXTabSheet;
    SpTBXTabItem4: TSpTBXTabItem;
    SpTBXTabSheetCmdLine: TSpTBXTabSheet;
    SpTBXTabItem5: TSpTBXTabItem;
    SpTBXTabSheetFilter: TSpTBXTabSheet;
    SpTBXTabItem6: TSpTBXTabItem;
    SpTBXTabSheetFavorites: TSpTBXTabSheet;
    SpTBXTabItem7: TSpTBXTabItem;
    SpTBXTabSheetHistory: TSpTBXTabSheet;
    TntActionListOptions: TTntActionList;
    ActionOptionsOk: TTntAction;
    ActionOptionsCancel: TTntAction;
    ActionOptionsApply: TTntAction;
    ActionOptionsHelp: TTntAction;
    SpTBXLabel3: TSpTBXLabel;
    ColorDialog: TColorDialog;
    FontDialog: TFontDialog;
    SpTBXTabItem8: TSpTBXTabItem;
    SpTBXTabSheet1: TSpTBXTabSheet;
    SpTBXRadioGroupDefaultNewTab: TSpTBXRadioGroup;
    TntOpenDialog: TTntOpenDialog;
    SpTBXGroupBoxTabSetOptions: TSpTBXGroupBox;
    SpTBXCheckBoxNetworkDrivesTab: TSpTBXCheckBox;
    SpTBXCheckBoxRemoveableDrivesTab: TSpTBXCheckBox;
    SpTBXCheckBoxHideTabsetWithOne: TSpTBXCheckBox;
    SpTBXGroupBoxFileObjects: TSpTBXGroupBox;
    SpTBXCheckBoxFolders: TSpTBXCheckBox;
    SpTBXCheckBoxNonFolders: TSpTBXCheckBox;
    SpTBXCheckBoxHidden: TSpTBXCheckBox;
    SpTBXCheckBoxShareable: TSpTBXCheckBox;
    SpTBXCheckBoxNetworkPrinters: TSpTBXCheckBox;
    SpTBXTabItemViewer: TSpTBXTabItem;
    SpTBXTabSheet2: TSpTBXTabSheet;
    SpTBXGroupBoxViewerExtensions: TSpTBXGroupBox;
    SpTBXEditViewerMediaExt: TSpTBXEdit;
    SpTBXEditViewerImageExt: TSpTBXEdit;
    SpTBXEditViewerTextExt: TSpTBXEdit;
    SpTBXLabelViewerText: TSpTBXLabel;
    SpTBXLabelViewerMedia: TSpTBXLabel;
    SpTBXLabelViewerImages: TSpTBXLabel;
    SpTBXLabelViewerInternet: TSpTBXLabel;
    SpTBXLabelViewerRTF: TSpTBXLabel;
    SpTBXEditViewerInternetExt: TSpTBXEdit;
    SpTBXEditViewerRTFExt: TSpTBXEdit;
    SpTBXGroupBoxViewerFont: TSpTBXGroupBox;
    SpTBXButtonAnsiFont: TSpTBXButton;
    SpTBXLabelAnsiFont: TSpTBXLabel;
    SpTBXLabelOemFont: TSpTBXLabel;
    SpTBXButtonOemFont: TSpTBXButton;
    SpTBXGroupBoxColors: TSpTBXGroupBox;
    SpTBXPanelTextWindowBkgnd: TSpTBXPanel;
    SpTBXLabel6: TSpTBXLabel;
    SpTBXLabel7: TSpTBXLabel;
    SpTBXLabel8: TSpTBXLabel;
    SpTBXPanelTextWindowHex1: TSpTBXPanel;
    SpTBXPanelTextWindowHex2: TSpTBXPanel;
    SpTBXGroupBoxGeneralOptions: TSpTBXGroupBox;
    SpTBXCheckBoxSingleInstance: TSpTBXCheckBox;
    SpTBXRightAlignSpacerItem1: TSpTBXRightAlignSpacerItem;
    SpTBXItemTabScrollRight: TSpTBXItem;
    SpTBXItemTabScrollLeft: TSpTBXItem;
    ImageList1: TImageList;
    SpTBXCheckBoxFullPathInAddress: TSpTBXCheckBox;
    SpTBXCheckBoxSuppressNoDiskMessages: TSpTBXCheckBox;
    SpTBXGroupBoxListviewGeneral: TSpTBXGroupBox;
    SpTBXGroupBoxListviewThumbnail: TSpTBXGroupBox;
    SpTBXCheckBoxListviewThumbsLoadAll: TSpTBXCheckBox;
    SpTBXLabel9: TSpTBXLabel;
    SpTBXLabel10: TSpTBXLabel;
    SpTBXSpinEditListviewThumbsWidth: TSpTBXSpinEdit;
    SpTBXSpinEditListviewThumbsHeight: TSpTBXSpinEdit;
    SpTBXCheckBoxCacheSingleFile: TSpTBXCheckBox;
    SpTBXButtonEditListviewThumbsCacheFile: TSpTBXButtonEdit;
    SpTBXCheckBoxThumbsCache: TSpTBXCheckBox;
    SpTBXCheckBoxListviewThumbsCompress: TSpTBXCheckBox;
    SpTBXRadioGroupGeneralStartup: TSpTBXRadioGroup;
    SpTBXButtonEditStartupCustomFolder: TSpTBXButtonEdit;
    SpTBXCheckBoxPathInCaption: TSpTBXCheckBox;
    SpTBXCheckBoxQueryInfoHints: TSpTBXCheckBox;
    SpTBXCheckBoxShowHints: TSpTBXCheckBox;
    SpTBXGroupBoxListviewColumnsViewOptions: TSpTBXGroupBox;
    SpTBXCheckBoxListviewHighlightColumn: TSpTBXCheckBox;
    DKLanguageControllerOptions: TDKLanguageController;
    SpTBXPanel1: TSpTBXPanel;
    SpTBXButtonOk: TSpTBXButton;
    SpTBXButtonCancel: TSpTBXButton;
    SpTBXButtonApply: TSpTBXButton;
    SpTBXButtonHelp: TSpTBXButton;
    SpTBXCheckBoxPerFolderSave: TSpTBXCheckBox;
    SpTBXGroupBoxListviewGrouping: TSpTBXGroupBox;
    SpTBXButtonEditGroupingCriteria: TSpTBXButton;
    SpTBXLabel11: TSpTBXLabel;
    SpTBXLabel12: TSpTBXLabel;
    SpTBXComboBoxDefaultColumn: TSpTBXComboBox;
    SpTBXLabel5: TSpTBXLabel;
    SpTBXEditColumnInHeaderMenu: TSpTBXEdit;
    SpTBXRadioColumnSortDirection: TSpTBXRadioGroup;
    SpTBXLabel13: TSpTBXLabel;
    SpTBXComboBoxDefaultGrouping: TSpTBXComboBox;
    SpTBXButtonColumnColor: TSpTBXButton;
    SpTBXPanelColumnColor: TSpTBXPanel;
    SpTBXCheckBoxGroupedByDefault: TSpTBXCheckBox;
    SpTBXLabelView: TSpTBXLabel;
    SpTBXComboBoxView: TSpTBXComboBox;
    SpTBXCheckBoxCopyPrevFolder: TSpTBXCheckBox;
    SpTBXCheckBoxSelectFirst: TSpTBXCheckBox;
    SpTBXButtonTextWindowBkgnd: TSpTBXButton;
    SpTBXButtonTextWindowHex1: TSpTBXButton;
    SpTBXButtonTextWindowHex2: TSpTBXButton;
    SpTBXGroupBoxGeneral: TSpTBXGroupBox;
    SpTBXCheckBoxTreeviewHoverAutoExpand: TSpTBXCheckBox;
    SpTBXCheckBoxTreeviewAutoHorzScroll: TSpTBXCheckBox;
    SpTBXCheckBoxTreeviewBranchLines: TSpTBXCheckBox;
    SpTBXGroupBoxTreeviewColors: TSpTBXGroupBox;
    SpTBXButtonTreeviewBkGndColor: TSpTBXButton;
    SpTBXButtonTreeviewFont: TSpTBXButton;
    SpTBXCheckBoxTreeviewHotTrack: TSpTBXCheckBox;
    SpTBXCheckBoxTreeviewFullRowSelect: TSpTBXCheckBox;
    SpTBXCheckBoxTreeviewSingleClickExpand: TSpTBXCheckBox;
    SpTBXGroupBoxColorFont: TSpTBXGroupBox;
    SpTBXGroupBoxHistoryGeneral: TSpTBXGroupBox;
    SpTBXCheckBoxOptionsHistoryDropWarning: TSpTBXCheckBox;
    SpTBXCheckBoxOptionsHistoryContextWarning: TSpTBXCheckBox;
    SpTBXGroupBoxHistoryColorFont: TSpTBXGroupBox;
    SpTBXButtonHistoryColor: TSpTBXButton;
    SpTBXButtonHistoryFont: TSpTBXButton;
    SpTBXGroupBoxFavoriteColorFont: TSpTBXGroupBox;
    SpTBXButtonFavoritesColor: TSpTBXButton;
    SpTBXButtonFavoritesFont: TSpTBXButton;
    SpTBXGroupBoxFavoriteGeneral: TSpTBXGroupBox;
    SpTBXCheckBoxOptionsFavoritesContextWarning: TSpTBXCheckBox;
    SpTBXCheckBoxOptionsFavoritesDropWarning: TSpTBXCheckBox;
    SpTBXGroupBoxFilterColorFont: TSpTBXGroupBox;
    SpTBXButtonFilterColor: TSpTBXButton;
    SpTBXButtonFilterFont: TSpTBXButton;
    SpTBXGroupBoxDropStackColorFont: TSpTBXGroupBox;
    SpTBXButtonDropStackColor: TSpTBXButton;
    SpTBXButtonDropStackFont: TSpTBXButton;
    SpTBXGroupBoxDropStackGeneral: TSpTBXGroupBox;
    SpTBXEditDropStackHintFiles: TSpTBXEdit;
    SpTBXLabelDropStackFileInHint: TSpTBXLabel;
    SpTBXEditDropStackDepth: TSpTBXEdit;
    SpTBXLabel2: TSpTBXLabel;
    SpTBXGroupBoxCmdLineColorFont: TSpTBXGroupBox;
    SpTBXButtonCmdLineWndColor: TSpTBXButton;
    SpTBXButtonCmdLineFont: TSpTBXButton;
    SpTBXGroupBoxCmdLineGeneral: TSpTBXGroupBox;
    SpTBXLabel1: TSpTBXLabel;
    SpTBXEditOptionsCmdLineDepth: TSpTBXEdit;
    SpTBXEditCmdLineSample: TSpTBXEdit;
    SpTBXEditTreeviewSample: TSpTBXEdit;
    SpTBXEditHistorySample: TSpTBXEdit;
    SpTBXEditFavoritesSample: TSpTBXEdit;
    SpTBXEditFilterSample: TSpTBXEdit;
    SpTBXEditDropStackSample: TSpTBXEdit;
    SpTBXButtonListviewFont: TSpTBXButton;
    SpTBXButtonListviewBkGndColor: TSpTBXButton;
    SpTBXEditListviewSample: TSpTBXEdit;
    SpTBXGroupBoxGeneralColorFont: TSpTBXGroupBox;
    SpTBXCheckBoxGeneralLockFonts: TSpTBXCheckBox;
    SpTBXCheckBoxGeneralLockColors: TSpTBXCheckBox;
    SpTBXCheckBoxFavoritesShowPathHint: TSpTBXCheckBox;
    SpTBXRadioGroupDropStackAutoRemove: TSpTBXRadioGroup;
    SpTBXCheckBoxDropStackContentsHint: TSpTBXCheckBox;
    SpTBXCheckBoxGeneralTrackFileSize: TSpTBXCheckBox;
    SpTBXCheckBoxGeneralTabsShowHints: TSpTBXCheckBox;
    SpTBXCheckBoxGeneralSaveMappedDrives: TSpTBXCheckBox;
    SpTBXCheckBoxHistorySaveRemovableDrives: TSpTBXCheckBox;
    SpTBXCheckBoxHistorySaveNetworkPaths: TSpTBXCheckBox;
    SpTBXCheckBoxHistorySaveMappedPaths: TSpTBXCheckBox;
    SpTBXCheckBoxTabsetShowFullPaths: TSpTBXCheckBox;
    SpTBXCheckBoxGeneralUseOnByDefaultFlag: TSpTBXCheckBox;
    SpTBXCheckBoxGeneralAutoCheckForUpdates: TSpTBXCheckBox;
    SpTBXPanelTextWindowHexBkGnd: TSpTBXPanel;
    SpTBXButtonHexBkGnd: TSpTBXButton;
    SpTBXLabel4: TSpTBXLabel;
    SpTBXTabItemToolbars: TSpTBXTabItem;
    SpTBXTabSheet3: TSpTBXTabSheet;
    SpTBXGroupBoxToobarDrives: TSpTBXGroupBox;
    SpTBXGroupBoxToolbarButtonWrap: TSpTBXGroupBox;
    SpTBXGroupBoxToolbarsGeneral: TSpTBXGroupBox;
    SpTBXCheckBoxGeneralShowCloseButtons: TSpTBXCheckBox;
    SpTBXRadioGroupToolbarsFavoriteCrumb: TSpTBXRadioGroup;
    SpTBXCheckBoxCmdLineSync: TSpTBXCheckBox;
    SpTBXCheckBoxShowTitleBar: TSpTBXCheckBox;
    SpTBXRadioGroupToolbarBreadCrumb: TSpTBXRadioGroup;
    SpTBXRadioGroupToolbarsButtonLayout: TSpTBXRadioGroup;
    SpTBXGroupBoxToolbarSpecialFolder: TSpTBXGroupBox;
    SpTBXCheckBoxToolbarsDrivesShowNetwork: TSpTBXCheckBox;
    SpTBXCheckBoxToolbarsDrivesShowControlPanel: TSpTBXCheckBox;
    SpTBXCheckBoxToolbarsDrivesShowRecycleBin: TSpTBXCheckBox;
    SpTBXCheckBoxToolbarsDrivesShowMyComputer: TSpTBXCheckBox;
    SpTBXCheckBoxToolbarDrivesShowHints: TSpTBXCheckBox;
    SpTBXCheckBoxShowPopupHints: TSpTBXCheckBox;
    SpTBXLabel14: TSpTBXLabel;
    SpTBXSpinEditListviewSmoothScroll: TSpTBXSpinEdit;
    SpTBXButtonEditDefaultNewTabLocation: TSpTBXButtonEdit;
    SpTBXCheckBoxGeneralTray: TSpTBXCheckBox;
    SpTBXGroupBox1: TSpTBXGroupBox;
    SpTBXCheckBoxFavoritesFullRowSelect: TSpTBXCheckBox;
    SpTBXCheckBoxFavoritesOpenInNewTab: TSpTBXCheckBox;
    SpTBXCheckBoxTreeviewShowToolTip: TSpTBXCheckBox;
    SpTBXTabItemFolderSize: TSpTBXTabItem;
    SpTBXTabSheet4: TSpTBXTabSheet;
    SpTBXCheckBoxFolderSizeShowColumn: TSpTBXCheckBox;
    SpTBXRadioGroupFolderSizeDisplayLayout: TSpTBXRadioGroup;
    SpTBXEditHistoryStackDepth: TSpTBXEdit;
    SpTBXLabel15: TSpTBXLabel;
    procedure ActionOptionsOkExecute(Sender: TObject);
    procedure ActionOptionsApplyExecute(Sender: TObject);
    procedure ActionOptionsHelpExecute(Sender: TObject);
    procedure SpTBXButton2Click(Sender: TObject);
    procedure ActionOptionsCancelExecute(Sender: TObject);
    procedure SpTBXButtonCmdLineWndColorClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpTBXButtonCmdLineFontClick(Sender: TObject);
    procedure SpTBXEditNumericKeyPress(Sender: TObject; var Key: Char);
    procedure SpTBXCheckBoxShellThumbsClick(Sender: TObject);
    procedure SpTBXRadioGroupDefaultNewTabClick(Sender: TObject);
    procedure SpTBXButtonCustomNewTabLocationClick(Sender: TObject);
    procedure SpTBXCheckBoxSetDirtyClick(Sender: TObject);
    procedure SpTBXEditColumnInHeaderMenuKeyPress(Sender: TObject; var Key: Char);
    procedure SpTBXEditColumnInHeaderMenuChange(Sender: TObject);
    procedure SpTBXButtonAnsiFontClick(Sender: TObject);
    procedure SpTBXButtonOemFontClick(Sender: TObject);
    procedure SpTBXEditViewerChange(Sender: TObject);
    procedure SpTBXCheckBoxSingleInstanceClick(Sender: TObject);
    procedure SpTBXItemTabScrollLeftClick(Sender: TObject);
    procedure SpTBXItemTabScrollRightClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SpTBXCheckBoxListviewHighlightColumnClick(Sender: TObject);
    procedure SpTBXSpinEditSetDirtyChange(Sender: TObject);
    procedure SpTBXCheckBoxThumbsCacheClick(Sender: TObject);
    procedure SpTBXButtonEditListviewThumbsCacheFileSubEditButton0Click(Sender: TObject);
    procedure SpTBXComboBoxIsDirtyChange(Sender: TObject);
    procedure SpTBXRadioGroupGeneralStartupClick(Sender: TObject);
    procedure SpTBXButtonEditStartupCustomFolderSubEditButton0Click(Sender: TObject);
    procedure SpTBXButtonEditGroupingCriteriaClick(Sender: TObject);
    procedure SpTBXButtonColumnColorClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SpTBXCheckBoxCacheSingleFileClick(Sender: TObject);
    procedure SpTBXButtonTextWindowBkgndClick(Sender: TObject);
    procedure SpTBXButtonTextWindowHex1Click(Sender: TObject);
    procedure SpTBXButtonTextWindowHex2Click(Sender: TObject);
    procedure SpTBXButtonTreeviewBkGndColorClick(Sender: TObject);
    procedure SpTBXButtonTreeviewFontClick(Sender: TObject);
    procedure SpTBXButtonHistoryColorClick(Sender: TObject);
    procedure SpTBXButtonHistoryFontClick(Sender: TObject);
    procedure SpTBXButtonFavoritesColorClick(Sender: TObject);
    procedure SpTBXButtonFavoritesFontClick(Sender: TObject);
    procedure SpTBXButtonFilterColorClick(Sender: TObject);
    procedure SpTBXButtonFilterFontClick(Sender: TObject);
    procedure SpTBXButtonDropStackColorClick(Sender: TObject);
    procedure SpTBXButtonDropStackFontClick(Sender: TObject);
    procedure SpTBXButtonListviewBkGndColorClick(Sender: TObject);
    procedure SpTBXButtonListviewFontClick(Sender: TObject);
    procedure SpTBXCheckBoxDropStackContentsHintClick(Sender: TObject);
    procedure SpTBXButtonHexBkGndClick(Sender: TObject);
    procedure SpTBXCheckBoxShowPopupHintsClick(Sender: TObject);
  private
    { Private declarations }
    FAnsiFont: TFont;
    FAttribs: TUltraAttribs;
    FCurrentFrame: TCustomForm;
    FCustomNewTabLocation: TNamespace;
    FIsDirty: Boolean;
    FOEMFont: TFont;
    FCustomStartupPath: TNamespace;
    FSpTBXDockHeader: TSpTBXDock;
    FSpTBXToolbar: TSpTBXToolbar;
    FTempColor: TColor;
    FTempFont: TFont;
    procedure SetIsDirty(const Value: Boolean);
  protected
    procedure ApplyChanges;
    function QueryModifyColor(var Color: TColor): Boolean;
    function QueryModifyFont(Font: TFont): Boolean;
    procedure CheckScrollButtonState;
    procedure SetAllWindowColors(Color: TColor);
    procedure SetAllWindowFonts(Font: TFont);
    procedure SyncControlsWithAttribs;
    property AnsiFont: TFont read FAnsiFont write FAnsiFont;
    property OEMFont: TFont read FOEMFont write FOEMFont;
    property TempColor: TColor read FTempColor write FTempColor;
    property TempFont: TFont read FTempFont write FTempFont;
  public
    { Public declarations }

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function QueryValidInteger(Edit: TSpTBXEdit): Boolean;
    property Attribs: TUltraAttribs read FAttribs write FAttribs;
    property CurrentFrame: TCustomForm read FCurrentFrame write FCurrentFrame;
    property CustomNewTabLocation: TNamespace read FCustomNewTabLocation write FCustomNewTabLocation;
    property CustomStartupPath: TNamespace read FCustomStartupPath write FCustomStartupPath;
    property IsDirty: Boolean read FIsDirty write SetIsDirty;
    property SpTBXDockHeader: TSpTBXDock read FSpTBXDockHeader write FSpTBXDockHeader;
    property SpTBXToolbar: TSpTBXToolbar read FSpTBXToolbar write FSpTBXToolbar;
  end;

implementation

{$R *.dfm}

uses
  UnitEditGroupingCriteria;

type
  TCmdLineAttribsHack = class(TCmdLineAttribs);


{ TFormUltraOptions }
function TTntFormUltraOptions.QueryValidInteger(Edit: TSpTBXEdit): Boolean;
begin
  Result := True;
  try
    StrToInt(Edit.Text)
  except
    Edit.SetFocus;
    Edit.SelectAll;
    beep;
  end
end;

procedure TTntFormUltraOptions.CheckScrollButtonState;
var
  L: Boolean;
  R: Boolean;
begin
  SpTBXTabControlOptions.ScrollState(L, R);
  SpTBXItemTabScrollLeft.Enabled := L;
  SpTBXItemTabScrollRight.Enabled := R;
end;

procedure TTntFormUltraOptions.FormShow(Sender: TObject);
begin
  SpTBXCheckBoxOptionsFavoritesDropWarning.Checked := Attribs.Favorites.WarnBeforeDropAction;
  SpTBXCheckBoxOptionsFavoritesContextWarning.Checked := Attribs.Favorites.WarnBeforeContextAction;
  SpTBXCheckBoxOptionsHistoryDropWarning.Checked := Attribs.History.WarnBeforeDropAction;
  SpTBXCheckBoxOptionsHistoryContextWarning.Checked := Attribs.History.WarnBeforeContextAction;
  SpTBXButtonEditDefaultNewTabLocation.Enabled := SpTBXRadioGroupDefaultNewTab.ItemIndex = 2;
  if Assigned(Attribs.LoadCallback) then
    Attribs.LoadCallback(Attribs);
  SyncControlsWithAttribs;
  CheckScrollButtonState;
  IsDirty := False
end;

constructor TTntFormUltraOptions.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  AnsiFont := TFont.Create;
  OEMFont := TFont.Create;
  TempFont := TFont.Create;
end;

destructor TTntFormUltraOptions.Destroy;
begin
  FreeAndNil(FCustomNewTabLocation);
  FreeAndNil(FCustomStartupPath);
  FreeAndNil(FAnsiFont);
  FreeAndNil(FOEMFont);
  FreeAndNil(FTempFont);
  inherited Destroy;
end;

procedure TTntFormUltraOptions.ApplyChanges;
begin
  if IsDirty and Assigned(Attribs.SaveCallback) then
  begin
    Attribs.ShowPopupHints := SpTBXCheckBoxShowPopupHints.Checked;

    Attribs.DropStack.Color := SpTBXEditDropStackSample.Color;
    Attribs.DropStack.Font.Assign(SpTBXEditDropStackSample.Font);
    Attribs.DropStack.Depth := StrToInt(SpTBXEditDropStackDepth.Text);
    Attribs.DropStack.HintCount := StrToInt(SpTBXEditDropStackHintFiles.Text);
    Attribs.DropStack.AutoRemove := TDropStackAutoRemove( SpTBXRadioGroupDropStackAutoRemove.ItemIndex);
    Attribs.DropStack.ContentsHint := SpTBXCheckBoxDropStackContentsHint.Checked;

    Attribs.CmdLine.Color := SpTBXEditCmdLineSample.Color;
    Attribs.CmdLine.Font.Assign(SpTBXEditCmdLineSample.Font);
    Attribs.CmdLine.MaxLineCount := StrToInt(SpTBXEditOptionsCmdLineDepth.Text);
    Attribs.CmdLine.SyncWithFolder := SpTBXCheckBoxCmdLineSync.Checked;

    Attribs.History.Color := SpTBXEditHistorySample.Color;
    Attribs.History.Font.Assign(SpTBXEditHistorySample.Font);
    Attribs.History.SaveRemovableDrivePaths := SpTBXCheckBoxHistorySaveRemovableDrives.Checked;
    Attribs.History.SaveNetworkPaths := SpTBXCheckBoxHistorySaveNetworkPaths.Checked;
    Attribs.History.SaveMappedPaths := SpTBXCheckBoxHistorySaveMappedPaths.Checked;
    Attribs.History.WarnBeforeContextAction := SpTBXCheckBoxOptionsHistoryContextWarning.Checked;
    Attribs.History.WarnBeforeDropAction := SpTBXCheckBoxOptionsHistoryDropWarning.Checked;

    Attribs.Favorites.Color := SpTBXEditFavoritesSample.Color;
    Attribs.Favorites.Font.Assign(SpTBXEditFavoritesSample.Font);
    Attribs.Favorites.ShowPathHint := SpTBXCheckBoxFavoritesShowPathHint.Checked;
    Attribs.Favorites.WarnBeforeDropAction := SpTBXCheckBoxOptionsFavoritesDropWarning.Checked;
    Attribs.Favorites.WarnBeforeContextAction := SpTBXCheckBoxOptionsFavoritesContextWarning.Checked;
    Attribs.Favorites.FullRowSelect := SpTBXCheckBoxFavoritesFullRowSelect.Checked;
    Attribs.Favorites.OpenFoldersInNewTab := SpTBXCheckBoxFavoritesOpenInNewTab.Checked;

    Attribs.Filter.Color := SpTBXEditFilterSample.Color;
    Attribs.Filter.Font.Assign(SpTBXEditFilterSample.Font);

    PIDLMgr.FreePIDL(Attribs.General.DefaultTabPIDL);
    PIDLMgr.FreePIDL(Attribs.General.DefaultStartupPath);

    // General Attribs Tab
    Attribs.General.DefaultTabPIDL := PIDLMgr.CopyPIDL(CustomNewTabLocation.AbsolutePIDL);
    Attribs.General.DefaultStartupPath := PIDLMgr.CopyPIDL(CustomStartupPath.AbsolutePIDL);
    Attribs.General.DefaultTab := TDefaultTabLocation( SpTBXRadioGroupDefaultNewTab.ItemIndex);
    Attribs.General.DefaultPath := TDefaultStartupPath( SpTBXRadioGroupGeneralStartup.ItemIndex);
    Attribs.Listview.HideTabsetWhenOneTab := SpTBXCheckBoxHideTabsetWithOne.Checked;
    Attribs.General.SaveRemovableDriveTabs := SpTBXCheckBoxRemoveableDrivesTab.Checked;
    Attribs.General.SaveNetworkPathTabs := SpTBXCheckBoxNetworkDrivesTab.Checked;
    Attribs.General.SingleInstance := SpTBXCheckBoxSingleInstance.Checked;
    Attribs.General.PathInCaption := SpTBXCheckBoxPathInCaption.Checked;
    Attribs.General.ShowHints := SpTBXCheckBoxShowHints.Checked;
    Attribs.General.ShowFullPathInAddressbar := SpTBXCheckBoxFullPathInAddress.Checked;
    Attribs.General.TrackSelectedSize := SpTBXCheckBoxGeneralTrackFileSize.Checked;
    Attribs.General.ShowTabPathHints := SpTBXCheckBoxGeneralTabsShowHints.Checked;
    Attribs.General.SaveMappedDriveTabs := SpTBXCheckBoxGeneralSaveMappedDrives.Checked;
    Attribs.General.FullPathInTabMenus := SpTBXCheckBoxTabsetShowFullPaths.Checked;
    Attribs.General.UseOnByDefaultFlag := SpTBXCheckBoxGeneralUseOnByDefaultFlag.Checked;
    Attribs.General.AutoCheckForUpdates := SpTBXCheckBoxGeneralAutoCheckForUpdates.Checked;
    Attribs.General.LockWindowFonts := SpTBXCheckBoxGeneralLockColors.Checked;
    Attribs.General.LockWindowColors := SpTBXCheckBoxGeneralLockFonts.Checked;
    Attribs.General.TrayIcon := SpTBXCheckBoxGeneralTray.Checked;

    // Toolbar Tab Attribs
    Attribs.Toolbars.BreadCrumbWrap := SpTBXRadioGroupToolbarBreadCrumb.ItemIndex;
    Attribs.Toolbars.FavoriteCrumbWrap := SpTBXRadioGroupToolbarsFavoriteCrumb.ItemIndex;
    Attribs.General.ShowCloseButtons := SpTBXCheckBoxGeneralShowCloseButtons.Checked; // Moved to Toolbars Tab
    Attribs.Toolbars.ButtonLayout := TUltraButtonLayout( SpTBXRadioGroupToolbarsButtonLayout.ItemIndex);
    Attribs.Toolbars.DriveShowNetwork := SpTBXCheckBoxToolbarsDrivesShowNetwork.Checked;
    Attribs.Toolbars.DriveShowControlPanel := SpTBXCheckBoxToolbarsDrivesShowControlPanel.Checked;
    Attribs.Toolbars.DriveShowRecycleBin := SpTBXCheckBoxToolbarsDrivesShowRecycleBin.Checked;
    Attribs.Toolbars.DriveShowMyComputer := SpTBXCheckBoxToolbarsDrivesShowMyComputer.Checked;
    Attribs.Toolbars.DriveShowHints := SpTBXCheckBoxToolbarDrivesShowHints.Checked;


    // Viewer Tab Attribs
    Attribs.Viewer.TextExtensions.Text := SpTBXEditViewerTextExt.Text;
    Attribs.Viewer.ImageExtensions.Text := SpTBXEditViewerImageExt.Text;
    Attribs.Viewer.MediaExtensions.Text := SpTBXEditViewerMediaExt.Text;
    Attribs.Viewer.InternetExtensions.Text := SpTBXEditViewerInternetExt.Text;
    Attribs.Viewer.RTFExtensions.Text := SpTBXEditViewerRTFExt.Text;
    Attribs.Viewer.TextBkGndColor := SpTBXPanelTextWindowBkgnd.Color;
    Attribs.Viewer.Hex1Color := SpTBXPanelTextWindowHex1.Color;
    Attribs.Viewer.Hex2Color := SpTBXPanelTextWindowHex2.Color;
    Attribs.Viewer.HexBkGndColor := SpTBXPanelTextWindowHexBkGnd.Color;
    Attribs.Viewer.OEMFont.Assign(OEMFont);
    Attribs.Viewer.Font.Assign(AnsiFont);

    // Listview Tab Attribs
    Attribs.Listview.FileObjects := [];
    if SpTBXCheckBoxFolders.Checked then
      Attribs.Listview.FileObjects := Attribs.Listview.FileObjects + [foFolders];
    if SpTBXCheckBoxNonFolders.Checked then
      Attribs.Listview.FileObjects := Attribs.Listview.FileObjects + [foNonFolders];
    if SpTBXCheckBoxHidden.Checked then
      Attribs.Listview.FileObjects := Attribs.Listview.FileObjects + [foHidden];
    if SpTBXCheckBoxShareable.Checked then
      Attribs.Listview.FileObjects := Attribs.Listview.FileObjects + [foShareable];
    if SpTBXCheckBoxNetworkPrinters.Checked then
      Attribs.Listview.FileObjects := Attribs.Listview.FileObjects + [foNetworkPrinters];
    Attribs.Listview.ColumnsShownInHeaderMenu := StrToInt(SpTBXEditColumnInHeaderMenu.Text);
    Attribs.Listview.HilightColumnColor := SpTBXPanelColumnColor.Color;
    Attribs.Listview.HilightColumn := SpTBXCheckBoxListviewHighlightColumn.Checked;
    Attribs.General.SuppressNoDiskMessages := SpTBXCheckBoxSuppressNoDiskMessages.Checked;
    Attribs.Listview.ThumbsLoadAll := SpTBXCheckBoxListviewThumbsLoadAll.Checked;
    Attribs.Listview.ThumbsSingleFile := SpTBXCheckBoxCacheSingleFile.Checked;
    Attribs.Listview.ThumbsWidth := StrToInt(SpTBXSpinEditListviewThumbsWidth.Text);
    Attribs.Listview.ThumbsHeight := StrToInt(SpTBXSpinEditListviewThumbsHeight.Text);
    Attribs.Listview.ThumbsCacheFile := SpTBXButtonEditListviewThumbsCacheFile.Text;
    Attribs.Listview.ThumbsCache := SpTBXCheckBoxThumbsCache.Checked;
    Attribs.Listview.ThumbsCompress := SpTBXCheckBoxListviewThumbsCompress.Checked;
    Attribs.Listview.DefaultColumn := SpTBXComboBoxDefaultColumn.ItemIndex;
    Attribs.Listview.QueryInfoHints := SpTBXCheckBoxQueryInfoHints.Checked;
    Attribs.Listview.GroupedByDefault := SpTBXCheckBoxGroupedByDefault.Checked;
    Attribs.Listview.SavePerFolder := SpTBXCheckBoxPerFolderSave.Checked;
    Attribs.Listview.DefaultGroup := SpTBXComboBoxDefaultGrouping.ItemIndex;
    Attribs.Listview.CopyPrevView := SpTBXCheckBoxCopyPrevFolder.Checked;
    Attribs.Listview.SelectFirstItem := SpTBXCheckBoxSelectFirst.Checked;
    if SpTBXRadioColumnSortDirection.ItemIndex = 0 then
      Attribs.Listview.SortDirection := esdAscending
    else
      Attribs.Listview.SortDirection := esdDescending;
    Attribs.Listview.DefaultView := SpTBXComboBoxView.ItemIndex;
    Attribs.Listview.Color := SpTBXEditListviewSample.Color;
    Attribs.Listview.Font.Assign(SpTBXEditListviewSample.Font);
    Attribs.Listview.ShowTitleBar := SpTBXCheckBoxShowTitleBar.Checked;
    Attribs.Listview.SmoothScroll := StrToInt(SpTBXSpinEditListviewSmoothScroll.Text);
    Attribs.Listview.FolderSizeDisplay := TBtyeSize( SpTBXRadioGroupFolderSizeDisplayLayout.ItemIndex);
    Attribs.Listview.FolderSizeShow := SpTBXCheckBoxFolderSizeShowColumn.Checked;

    // Treeview
    Attribs.Treeview.Color := SpTBXEditTreeviewSample.Color;
    Attribs.Treeview.Font.Assign(SpTBXEditTreeviewSample.Font);
    Attribs.Treeview.HoverExpand := SpTBXCheckBoxTreeviewHoverAutoExpand.Checked;
    Attribs.Treeview.AutoHorzScroll := SpTBXCheckBoxTreeviewAutoHorzScroll.Checked;
    Attribs.Treeview.ShowBranchLines := SpTBXCheckBoxTreeviewBranchLines.Checked;
    Attribs.Treeview.HotTrack := SpTBXCheckBoxTreeviewHotTrack.Checked;
    Attribs.Treeview.FullRowSelect := SpTBXCheckBoxTreeviewFullRowSelect.Checked;
    Attribs.Treeview.SingleClickExpand := SpTBXCheckBoxTreeviewSingleClickExpand.Checked;
    Attribs.Treeview.ShowToolTip := SpTBXCheckBoxTreeviewShowToolTip.Checked;

    IsDirty := False;
    if Assigned(Attribs.SaveCallback) then
      Attribs.SaveCallback(Attribs);
    if Assigned(Attribs.ApplyCallback) then
      Attribs.ApplyCallback(Self);
    ShowHint := Attribs.General.ShowHints;
  end
end;

procedure TTntFormUltraOptions.ActionOptionsOkExecute(Sender: TObject);
begin
  ApplyChanges;
  Close;
end;

procedure TTntFormUltraOptions.ActionOptionsApplyExecute(Sender: TObject);
begin
  ApplyChanges
end;

procedure TTntFormUltraOptions.ActionOptionsHelpExecute(Sender: TObject);
begin
  beep
end;

function TTntFormUltraOptions.QueryModifyColor(var Color: TColor): Boolean;
begin
  Result := False;
  ColorDialog.Color := Color;
  if ColorDialog.Execute then
  begin
    Color := ColorDialog.Color;
    Result := True
  end
end;

function TTntFormUltraOptions.QueryModifyFont(Font: TFont): Boolean;
begin
  Result := False;
  FontDialog.Font.Assign(Font);
  if FontDialog.Execute then
  begin
    Font.Assign(FontDialog.Font);
    Result := True
  end
end;

procedure TTntFormUltraOptions.SetAllWindowColors(Color: TColor);
begin
  SpTBXEditTreeviewSample.Color := Color;
  SpTBXEditListviewSample.Color := Color;
  SpTBXEditFilterSample.Color := Color;
  SpTBXEditDropStackSample.Color := Color;
  SpTBXEditHistorySample.Color := Color;
  SpTBXEditFavoritesSample.Color := Color;
end;

procedure TTntFormUltraOptions.SetAllWindowFonts(Font: TFont);
begin
  SpTBXEditTreeviewSample.Font.Assign(Font);
  SpTBXEditListviewSample.Font.Assign(Font);
  SpTBXEditFilterSample.Font.Assign(Font);
  SpTBXEditDropStackSample.Font.Assign(Font);
  SpTBXEditHistorySample.Font.Assign(Font);
  SpTBXEditFavoritesSample.Font.Assign(Font);
end;

procedure TTntFormUltraOptions.SetIsDirty(const Value: Boolean);
begin
  if not (csLoading in ComponentState) then
  begin
    FIsDirty := Value;
    ActionOptionsApply.Enabled := FIsDirty
  end
end;

procedure TTntFormUltraOptions.SpTBXButton2Click(Sender: TObject);
begin
  beep;
end;

procedure TTntFormUltraOptions.ActionOptionsCancelExecute(Sender: TObject);
begin
  Close;
end;

procedure TTntFormUltraOptions.SpTBXButtonCmdLineWndColorClick(
  Sender: TObject);
begin
  TempColor := TCmdLineAttribsHack( Attribs.CmdLine).FColor;
  if QueryModifyColor(FTempColor) then
  begin
    IsDirty := True;
    SpTBXEditCmdLineSample.Color := TempColor
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonCmdLineFontClick(Sender: TObject);
begin
  TempFont.Assign(Attribs.CmdLine.Font);
  if QueryModifyFont(TempFont) then
  begin
    Attribs.CmdLine.Font.Assign(TempFont);
    SpTBXEditCmdLineSample.Font.Assign(Attribs.CmdLine.Font);
    IsDirty := True
  end
end;

procedure TTntFormUltraOptions.SyncControlsWithAttribs;
begin
  SpTBXEditOptionsCmdLineDepth.Text := IntToStr(Attribs.CmdLine.MaxLineCount);
  SpTBXEditCmdLineSample.Font.Assign(Attribs.CmdLine.Font);
  SpTBXEditCmdLineSample.Color := Attribs.CmdLine.Color;
  SpTBXEditOptionsCmdLineDepth.Text := IntToStr(Attribs.CmdLine.MaxLineCount);
  SpTBXCheckBoxCmdLineSync.Checked := Attribs.CmdLine.SyncWithFolder;

  SpTBXEditDropStackDepth.Text := IntToStr(Attribs.DropStack.Depth);
  SpTBXEditDropStackHintFiles.Text := IntToStr(Attribs.DropStack.HintCount);
  SpTBXEditDropStackSample.Color := Attribs.DropStack.Color;
  SpTBXEditDropStackSample.Font.Assign(Attribs.DropStack.Font);
  SpTBXRadioGroupDropStackAutoRemove.ItemIndex := Integer(Attribs.DropStack.AutoRemove);
  SpTBXCheckBoxDropStackContentsHint.Checked := Attribs.DropStack.ContentsHint;
  SpTBXEditDropStackHintFiles.Enabled := SpTBXCheckBoxDropStackContentsHint.Checked;
  SpTBXLabelDropStackFileInHint.Enabled := SpTBXCheckBoxDropStackContentsHint.Checked;

  SpTBXEditHistorySample.Color := Attribs.History.Color;
  SpTBXEditHistorySample.Font.Assign(Attribs.History.Font);
  SpTBXCheckBoxOptionsHistoryContextWarning.Checked := Attribs.History.WarnBeforeContextAction;
  SpTBXCheckBoxOptionsHistoryDropWarning.Checked := Attribs.History.WarnBeforeDropAction;

  SpTBXCheckBoxHistorySaveRemovableDrives.Checked := Attribs.History.SaveRemovableDrivePaths;
  SpTBXCheckBoxHistorySaveNetworkPaths.Checked := Attribs.History.SaveNetworkPaths;
  SpTBXCheckBoxHistorySaveMappedPaths.Checked := Attribs.History.SaveMappedPaths;

  SpTBXEditFavoritesSample.Color := Attribs.Favorites.Color;
  SpTBXEditFavoritesSample.Font.Assign(Attribs.Favorites.Font);
  SpTBXCheckBoxFavoritesShowPathHint.Checked := Attribs.Favorites.ShowPathHint;
  SpTBXCheckBoxOptionsFavoritesDropWarning.Checked := Attribs.Favorites.WarnBeforeDropAction;
  SpTBXCheckBoxOptionsFavoritesContextWarning.Checked := Attribs.Favorites.WarnBeforeContextAction;
  SpTBXCheckBoxFavoritesFullRowSelect.Checked := Attribs.Favorites.FullRowSelect;
  SpTBXCheckBoxFavoritesOpenInNewTab.Checked := Attribs.Favorites.OpenFoldersInNewTab;

  SpTBXEditFilterSample.Color := Attribs.Filter.Color;
  SpTBXEditFilterSample.Font.Assign(Attribs.Filter.Font);

  CustomNewTabLocation := TNamespace.Create(PIDLMgr.CopyPIDL(Attribs.General.DefaultTabPIDL), nil);
  CustomStartupPath := TNamespace.Create(PIDLMgr.CopyPIDL(Attribs.General.DefaultStartupPath), nil);
  SpTBXButtonEditDefaultNewTabLocation.Text := CustomNewTabLocation.NameAddressbar;
  SpTBXButtonEditStartupCustomFolder.Text := CustomStartupPath.NameAddressbar;
  SpTBXRadioGroupDefaultNewTab.ItemIndex := Integer( Attribs.General.DefaultTab);
  SpTBXRadioGroupGeneralStartup.ItemIndex := Integer( Attribs.General.DefaultPath);        
  SpTBXCheckBoxHideTabsetWithOne.Checked := Attribs.Listview.HideTabsetWhenOneTab;
  SpTBXCheckBoxRemoveableDrivesTab.Checked := Attribs.General.SaveRemovableDriveTabs;
  SpTBXCheckBoxNetworkDrivesTab.Checked := Attribs.General.SaveNetworkPathTabs;
  SpTBXCheckBoxShowHints.Checked := Attribs.General.ShowHints;
  SpTBXCheckBoxSingleInstance.Checked := Attribs.General.SingleInstance;
  SpTBXCheckBoxPathInCaption.Checked := Attribs.General.PathInCaption;
  SpTBXCheckBoxFullPathInAddress.Checked := Attribs.General.ShowFullPathInAddressbar;
  SpTBXCheckBoxSuppressNoDiskMessages.Checked := Attribs.General.SuppressNoDiskMessages;
  SpTBXCheckBoxGeneralTrackFileSize.Checked := Attribs.General.TrackSelectedSize;
  SpTBXCheckBoxGeneralTabsShowHints.Checked := Attribs.General.ShowTabPathHints;
  SpTBXCheckBoxGeneralSaveMappedDrives.Checked := Attribs.General.SaveMappedDriveTabs;
  ShowHint := Attribs.General.ShowHints;
  SpTBXCheckBoxTabsetShowFullPaths.Checked := Attribs.General.FullPathInTabMenus;
  SpTBXCheckBoxGeneralUseOnByDefaultFlag.Checked := Attribs.General.UseOnByDefaultFlag;
  SpTBXCheckBoxGeneralAutoCheckForUpdates.Checked := Attribs.General.AutoCheckForUpdates;
  SpTBXCheckBoxGeneralLockColors.Checked := Attribs.General.LockWindowFonts;
  SpTBXCheckBoxGeneralLockFonts.Checked := Attribs.General.LockWindowColors;
  SpTBXCheckBoxGeneralTray.Checked := Attribs.General.TrayIcon;

  // Toolbar Tab Attribs
  SpTBXCheckBoxGeneralShowCloseButtons.Checked := Attribs.General.ShowCloseButtons; // Moved to Toolbars Tab
  SpTBXRadioGroupToolbarBreadCrumb.ItemIndex := Attribs.Toolbars.BreadCrumbWrap;
  SpTBXRadioGroupToolbarsFavoriteCrumb.ItemIndex := Attribs.Toolbars.FavoriteCrumbWrap;
  SpTBXRadioGroupToolbarsButtonLayout.ItemIndex := Integer(Attribs.Toolbars.ButtonLayout);
  SpTBXCheckBoxToolbarsDrivesShowNetwork.Checked := Attribs.Toolbars.DriveShowNetwork;
  SpTBXCheckBoxToolbarsDrivesShowControlPanel.Checked := Attribs.Toolbars.DriveShowControlPanel;
  SpTBXCheckBoxToolbarsDrivesShowRecycleBin.Checked := Attribs.Toolbars.DriveShowRecycleBin;
  SpTBXCheckBoxToolbarsDrivesShowMyComputer.Checked := Attribs.Toolbars.DriveShowMyComputer;
  SpTBXCheckBoxToolbarDrivesShowHints.Checked := Attribs.Toolbars.DriveShowHints;

  SpTBXEditColumnInHeaderMenu.Text := IntToStr(Attribs.Listview.ColumnsShownInHeaderMenu);
  SpTBXCheckBoxFolders.Checked := foFolders in Attribs.Listview.FileObjects;
  SpTBXCheckBoxNonFolders.Checked := foNonFolders in Attribs.Listview.FileObjects;
  SpTBXCheckBoxHidden.Checked := foHidden in Attribs.Listview.FileObjects;
  SpTBXCheckBoxShareable.Checked := foShareable in Attribs.Listview.FileObjects;
  SpTBXCheckBoxNetworkPrinters.Checked := foNetworkPrinters in Attribs.Listview.FileObjects;
  SpTBXCheckBoxGroupedByDefault.Checked := Attribs.Listview.GroupedByDefault;
  SpTBXCheckBoxQueryInfoHints.Checked := Attribs.Listview.QueryInfoHints;
  SpTBXButtonColumnColor.Enabled := Attribs.Listview.HilightColumn;
  SpTBXPanelColumnColor.Color := Attribs.Listview.HilightColumnColor;
  SpTBXCheckBoxListviewHighlightColumn.Checked := Attribs.Listview.HilightColumn;
  SpTBXCheckBoxListviewThumbsLoadAll.Checked := Attribs.Listview.ThumbsLoadAll;
  SpTBXCheckBoxCacheSingleFile.Checked := Attribs.Listview.ThumbsSingleFile;
  SpTBXSpinEditListviewThumbsWidth.Text := IntToStr(Attribs.Listview.ThumbsWidth);
  SpTBXSpinEditListviewThumbsHeight.Text := IntToStr(Attribs.Listview.ThumbsHeight);
  SpTBXButtonEditListviewThumbsCacheFile.Text := Attribs.Listview.ThumbsCacheFile;
  SpTBXCheckBoxThumbsCache.Checked := Attribs.Listview.ThumbsCache;
  SpTBXCheckBoxListviewThumbsCompress.Checked := Attribs.Listview.ThumbsCompress;
  SpTBXComboBoxDefaultColumn.ItemIndex := Attribs.Listview.DefaultColumn;
  SpTBXCheckBoxPerFolderSave.Checked := Attribs.Listview.SavePerFolder;
  SpTBXComboBoxDefaultGrouping.ItemIndex := Attribs.Listview.DefaultGroup;
  SpTBXCheckBoxCopyPrevFolder.Checked := Attribs.Listview.CopyPrevView;
  SpTBXCheckBoxSelectFirst.Checked := Attribs.Listview.SelectFirstItem;
  if Attribs.Listview.SortDirection = esdDescending then
    SpTBXRadioColumnSortDirection.ItemIndex := 1
  else
    SpTBXRadioColumnSortDirection.ItemIndex := 0;
  SpTBXComboBoxView.ItemIndex := Integer( Attribs.Listview.DefaultView);
  SpTBXEditListviewSample.Color := Attribs.Listview.Color;
  SpTBXEditListviewSample.Font.Assign(Attribs.Listview.Font);
  SpTBXCheckBoxShowTitleBar.Checked := Attribs.Listview.ShowTitleBar;
  SpTBXSpinEditListviewSmoothScroll.Text := IntToStr(Attribs.Listview.SmoothScroll);
  SpTBXRadioGroupFolderSizeDisplayLayout.ItemIndex := Integer(Attribs.Listview.FolderSizeDisplay);
  SpTBXCheckBoxFolderSizeShowColumn.Checked := Attribs.Listview.FolderSizeShow;

  SpTBXEditViewerTextExt.Text := Trim(Attribs.Viewer.TextExtensions.Text);
  SpTBXEditViewerImageExt.Text := Trim(Attribs.Viewer.ImageExtensions.Text);
  SpTBXEditViewerMediaExt.Text := Trim(Attribs.Viewer.MediaExtensions.Text);
  SpTBXEditViewerInternetExt.Text := Trim(Attribs.Viewer.InternetExtensions.Text);
  SpTBXEditViewerRTFExt.Text := Trim(Attribs.Viewer.RTFExtensions.Text);
  SpTBXPanelTextWindowBkgnd.Color := Attribs.Viewer.TextBkGndColor;
  SpTBXPanelTextWindowHex1.Color := Attribs.Viewer.Hex1Color;
  SpTBXPanelTextWindowHex2.Color := Attribs.Viewer.Hex2Color;
  SpTBXPanelTextWindowHexBkGnd.Color := Attribs.Viewer.HexBkGndColor;
  OEMFont.Assign(Attribs.Viewer.OEMFont);
  AnsiFont.Assign(Attribs.Viewer.Font);

  SpTBXEditTreeviewSample.Color := Attribs.Treeview.Color;
  SpTBXEditTreeviewSample.Font.Assign(Attribs.Treeview.Font);
  SpTBXCheckBoxTreeviewHoverAutoExpand.Checked := Attribs.Treeview.HoverExpand;
  SpTBXCheckBoxTreeviewAutoHorzScroll.Checked := Attribs.Treeview.AutoHorzScroll;
  SpTBXCheckBoxTreeviewBranchLines.Checked := Attribs.Treeview.ShowBranchLines;
  SpTBXCheckBoxTreeviewHotTrack.Checked := Attribs.Treeview.HotTrack;
  SpTBXCheckBoxTreeviewFullRowSelect.Checked := Attribs.Treeview.FullRowSelect;
  SpTBXCheckBoxTreeviewSingleClickExpand.Checked := Attribs.Treeview.SingleClickExpand;
  SpTBXCheckBoxTreeviewShowToolTip.Checked := Attribs.Treeview.ShowToolTip;

  SpTBXCheckBoxShowPopupHints.Checked := Attribs.ShowPopupHints;
end;

procedure TTntFormUltraOptions.SpTBXEditNumericKeyPress(
  Sender: TObject; var Key: Char);
begin
  if not (Key in NUMERIC_KEYS) then
    Key := #0;
  IsDirty := True
end;

procedure TTntFormUltraOptions.SpTBXCheckBoxShellThumbsClick(Sender: TObject);
begin
  IsDirty := True
end;

procedure TTntFormUltraOptions.SpTBXRadioGroupDefaultNewTabClick(
  Sender: TObject);
begin
  SpTBXButtonEditDefaultNewTabLocation.Enabled := SpTBXRadioGroupDefaultNewTab.ItemIndex = 1;
  IsDirty := True
end;

procedure TTntFormUltraOptions.SpTBXButtonCustomNewTabLocationClick(Sender: TObject);
var
  OutPIDL: PItemIDList;
begin
  if UltraSelectDirectory(Handle, CustomNewTabLocation.AbsolutePIDL, OutPIDL) then
  begin
    FreeAndNil(FCustomNewTabLocation);
    CustomNewTabLocation := TNamespace.Create(OutPIDL, nil);
    SpTBXButtonEditDefaultNewTabLocation.Text := CustomNewTabLocation.NameAddressbar;
    IsDirty := True;
  end;
end;

procedure TTntFormUltraOptions.SpTBXCheckBoxSetDirtyClick(
  Sender: TObject);
begin
  IsDirty := True;
end;

procedure TTntFormUltraOptions.SpTBXEditColumnInHeaderMenuKeyPress(
  Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) then
  begin
    Key := #0;
    if (Key <> #13) then
      Beep
  end
end;

procedure TTntFormUltraOptions.SpTBXEditColumnInHeaderMenuChange(
  Sender: TObject);
begin
  IsDirty := True
end;

procedure TTntFormUltraOptions.SpTBXButtonAnsiFontClick(Sender: TObject);
begin
  FontDialog.Font.Assign(AnsiFont);
  if FontDialog.Execute then
  begin
    AnsiFont.Assign(FontDialog.Font);
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonOemFontClick(Sender: TObject);
begin
  FontDialog.Font.Assign(OEMFont);
  if FontDialog.Execute then
  begin
    OEMFont.Assign(FontDialog.Font);
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXEditViewerChange(Sender: TObject);
begin
  IsDirty := True
end;

procedure TTntFormUltraOptions.SpTBXCheckBoxSingleInstanceClick(
  Sender: TObject);
begin
  IsDirty := True
end;

procedure TTntFormUltraOptions.SpTBXItemTabScrollLeftClick(Sender: TObject);
begin
  SpTBXTabControlOptions.ScrollLeft;
  CheckScrollButtonState;
end;

procedure TTntFormUltraOptions.SpTBXItemTabScrollRightClick(Sender: TObject);
begin
  SpTBXTabControlOptions.ScrollRight;
  CheckScrollButtonState;
end;

procedure TTntFormUltraOptions.FormResize(Sender: TObject);
begin
  CheckScrollButtonState
end;

procedure TTntFormUltraOptions.SpTBXCheckBoxListviewHighlightColumnClick(
  Sender: TObject);
begin
  SpTBXButtonColumnColor.Enabled := SpTBXCheckBoxListviewHighlightColumn.Checked;
  IsDirty := True
end;

procedure TTntFormUltraOptions.SpTBXSpinEditSetDirtyChange(
  Sender: TObject);
begin
  IsDirty := True;
end;

procedure TTntFormUltraOptions.SpTBXCheckBoxThumbsCacheClick(Sender: TObject);
begin
  IsDirty := True;
  SpTBXCheckBoxCacheSingleFile.Enabled := SpTBXCheckBoxThumbsCache.Checked;
  SpTBXButtonEditListviewThumbsCacheFile.Enabled := SpTBXCheckBoxCacheSingleFile.Enabled and SpTBXCheckBoxCacheSingleFile.Checked;
  SpTBXCheckBoxListviewThumbsCompress.Enabled := SpTBXCheckBoxThumbsCache.Checked;
end;

procedure TTntFormUltraOptions.SpTBXButtonEditListviewThumbsCacheFileSubEditButton0Click(
  Sender: TObject);
begin
  TntOpenDialog.FileName := SpTBXButtonEditListviewThumbsCacheFile.Text;
  if TntOpenDialog.Execute then
  begin
    IsDirty := True;
    SpTBXButtonEditListviewThumbsCacheFile.Text := TntOpenDialog.FileName
  end
end;

procedure TTntFormUltraOptions.SpTBXComboBoxIsDirtyChange(Sender: TObject);
begin
  IsDirty := True
end;

procedure TTntFormUltraOptions.SpTBXRadioGroupGeneralStartupClick(Sender: TObject);
begin
  SpTBXButtonEditStartupCustomFolder.Enabled := SpTBXRadioGroupGeneralStartup.ItemIndex = 1;
  IsDirty := True;
end;

procedure TTntFormUltraOptions.SpTBXButtonEditStartupCustomFolderSubEditButton0Click(
  Sender: TObject);
var
  OutPIDL: PItemIDList;
begin
  if UltraSelectDirectory(Handle, CustomStartupPath.AbsolutePIDL, OutPIDL) then
  begin
    FreeAndNil(FCustomStartupPath);
    CustomStartupPath := TNamespace.Create(OutPIDL, nil);
    SpTBXButtonEditStartupCustomFolder.Text := CustomStartupPath.NameAddressbar;
    IsDirty := True;
  end;
end;

procedure TTntFormUltraOptions.SpTBXButtonEditGroupingCriteriaClick(Sender: TObject);
begin
  if EditGroupingCriteria(Self, SpTBXDockHeader, SpTBXToolbar) then
    IsDirty := True
end;

procedure TTntFormUltraOptions.SpTBXButtonColumnColorClick(Sender: TObject);
begin
  ColorDialog.Color := SpTBXPanelColumnColor.Color;
  if ColorDialog.Execute then
  begin
    SpTBXPanelColumnColor.Color := ColorDialog.Color;
    IsDirty := True
  end
end;

procedure TTntFormUltraOptions.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Close
end;

procedure TTntFormUltraOptions.SpTBXCheckBoxCacheSingleFileClick(
  Sender: TObject);
begin
  IsDirty := True;
  SpTBXButtonEditListviewThumbsCacheFile.Enabled := SpTBXCheckBoxCacheSingleFile.Checked
end;

procedure TTntFormUltraOptions.SpTBXButtonTextWindowBkgndClick(
  Sender: TObject);
begin
  ColorDialog.Color := SpTBXPanelTextWindowBkgnd.Color;
  if ColorDialog.Execute then
  begin
    SpTBXPanelTextWindowBkgnd.Color := ColorDialog.Color;
    SpTBXPanelTextWindowBkgnd.InvalidateBackground;
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonTextWindowHex1Click(
  Sender: TObject);
begin
  ColorDialog.Color := SpTBXPanelTextWindowHex1.Color;
  if ColorDialog.Execute then
  begin
    SpTBXPanelTextWindowHex1.Color := ColorDialog.Color;
    SpTBXPanelTextWindowHex1.InvalidateBackground;
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonTextWindowHex2Click(
  Sender: TObject);
begin
  ColorDialog.Color := SpTBXPanelTextWindowHex2.Color;
  if ColorDialog.Execute then
  begin
    SpTBXPanelTextWindowHex2.Color := ColorDialog.Color;
    SpTBXPanelTextWindowHex2.InvalidateBackground;
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonHexBkGndClick(Sender: TObject);
begin
  ColorDialog.Color := SpTBXPanelTextWindowHexBkGnd.Color;
  if ColorDialog.Execute then
  begin
    SpTBXPanelTextWindowHexBkGnd.Color := ColorDialog.Color;
    SpTBXPanelTextWindowHexBkGnd.InvalidateBackground;
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonTreeviewBkGndColorClick(
  Sender: TObject);
begin
  TempColor := SpTBXEditTreeviewSample.Color;
  if QueryModifyColor(FTempColor) then
  begin
    if SpTBXCheckBoxGeneralLockColors.Checked then
      SetAllWindowColors(ColorDialog.Color)
    else
      SpTBXEditTreeviewSample.Color := ColorDialog.Color;
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonTreeviewFontClick(Sender: TObject);
begin
  TempFont.Assign(SpTBXEditTreeviewSample.Font);
  if QueryModifyFont(TempFont) then
  begin
    if SpTBXCheckBoxGeneralLockFonts.Checked then
      SetAllWindowFonts(TempFont)
    else
      SpTBXEditTreeviewSample.Font.Assign(TempFont);
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonHistoryColorClick(Sender: TObject);
begin
  TempColor := SpTBXEditHistorySample.Color;
  if QueryModifyColor(FTempColor) then
  begin
    if SpTBXCheckBoxGeneralLockColors.Checked then
      SetAllWindowColors(ColorDialog.Color)
    else
      SpTBXEditHistorySample.Color := ColorDialog.Color;
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonHistoryFontClick(Sender: TObject);
begin
  TempFont.Assign(SpTBXEditHistorySample.Font);
  if QueryModifyFont(TempFont) then
  begin
    if SpTBXCheckBoxGeneralLockFonts.Checked then
      SetAllWindowFonts(TempFont)
    else
      SpTBXEditHistorySample.Font.Assign(TempFont);
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonFavoritesColorClick(Sender: TObject);
begin
  TempColor := SpTBXEditFavoritesSample.Color;
  if QueryModifyColor(FTempColor) then
  begin
    if SpTBXCheckBoxGeneralLockColors.Checked then
      SetAllWindowColors(ColorDialog.Color)
    else
      SpTBXEditFavoritesSample.Color := ColorDialog.Color;
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonFavoritesFontClick(Sender: TObject);
begin
  TempFont.Assign(SpTBXEditFavoritesSample.Font);
  if QueryModifyFont(TempFont) then
  begin
    if SpTBXCheckBoxGeneralLockFonts.Checked then
      SetAllWindowFonts(TempFont)
    else
      SpTBXEditFavoritesSample.Font.Assign(TempFont);
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonFilterColorClick(Sender: TObject);
begin
  TempColor := SpTBXEditFilterSample.Color;
  if QueryModifyColor(FTempColor) then
  begin
    if SpTBXCheckBoxGeneralLockColors.Checked then
      SetAllWindowColors(ColorDialog.Color)
    else
      SpTBXEditFilterSample.Color := ColorDialog.Color;
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonFilterFontClick(Sender: TObject);
begin
  TempFont.Assign(SpTBXEditFilterSample.Font);
  if QueryModifyFont(TempFont) then
  begin
    if SpTBXCheckBoxGeneralLockFonts.Checked then
      SetAllWindowFonts(TempFont)
    else
      SpTBXEditFilterSample.Font.Assign(TempFont);
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonDropStackColorClick(
  Sender: TObject);
begin
  TempColor := SpTBXEditDropStackSample.Color;
  if QueryModifyColor(FTempColor) then
  begin
    if SpTBXCheckBoxGeneralLockColors.Checked then
      SetAllWindowColors(ColorDialog.Color)
    else
      SpTBXEditDropStackSample.Color := ColorDialog.Color;
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonDropStackFontClick(Sender: TObject);
begin
  TempFont.Assign(SpTBXEditDropStackSample.Font);
  if QueryModifyFont(TempFont) then
  begin
    if SpTBXCheckBoxGeneralLockFonts.Checked then
      SetAllWindowFonts(TempFont)
    else
      SpTBXEditDropStackSample.Font.Assign(TempFont);
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonListviewBkGndColorClick(
  Sender: TObject);
begin
  TempColor := SpTBXEditListviewSample.Color;
  if QueryModifyColor(FTempColor) then
  begin
    if SpTBXCheckBoxGeneralLockColors.Checked then
      SetAllWindowColors(ColorDialog.Color)
    else
      SpTBXEditListviewSample.Color := ColorDialog.Color;
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXButtonListviewFontClick(Sender: TObject);
begin
  TempFont.Assign(SpTBXEditListviewSample.Font);
  if QueryModifyFont(TempFont) then
  begin
    if SpTBXCheckBoxGeneralLockFonts.Checked then
      SetAllWindowFonts(TempFont)
    else
      SpTBXEditListviewSample.Font.Assign(TempFont);
    IsDirty := True;
  end
end;

procedure TTntFormUltraOptions.SpTBXCheckBoxDropStackContentsHintClick(
  Sender: TObject);
begin
  SpTBXEditDropStackHintFiles.Enabled := SpTBXCheckBoxDropStackContentsHint.Checked;
  SpTBXLabelDropStackFileInHint.Enabled := SpTBXCheckBoxDropStackContentsHint.Checked;
  IsDirty := True
end;

procedure TTntFormUltraOptions.SpTBXCheckBoxShowPopupHintsClick(
  Sender: TObject);
begin
  ShowHint := SpTBXCheckBoxShowPopupHints.Checked;
  IsDirty := True
end;

initialization
  RegisterClasses([TCmdLineAttribs, TFavoritesAttribs, TFilterAttribs, THistoryAttribs,
    TListviewAttribs, TTreeviewAttribs, TUltraAttribs]);

finalization


end.
