unit UnitOptionsListviewColumns;

// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you maynot use this file except in compliance
// with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
//
// Alternatively, you may redistribute this library, use and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software Foundation;
// either version 2.1 of the License, or (at your option) any later version.
// You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
// specific language governing rights and limitations under the License.

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  TntForms,
  SpTBXEditors,
  SpTBXControls,
  StdCtrls,
  TntStdCtrls,
  SpTBXDkPanels,
  DKLang,
  UltraOptions,
  UnitOptionsBase, SpTBXItem;

type
  TTntFormOptionsListviewColumns = class(TTntOptionsBaseForm)
    SpTBXPanel1: TSpTBXPanel;
    SpTBXGroupBoxListviewColumnsViewOptions: TSpTBXGroupBox;
    SpTBXLabel14: TSpTBXLabel;
    SpTBXSpinEditListviewSmoothScroll: TSpTBXSpinEdit;
    DKLanguageController1: TDKLanguageController;
    SpTBXLabelDefaultColumnWidth: TSpTBXLabel;
    SpTBXEditDefaultColumnWidth: TSpTBXEdit;
    SpTBXGroupBoxSorting: TSpTBXGroupBox;
    SpTBXComboBoxDefaultColumn: TSpTBXComboBox;
    SpTBXLabel12: TSpTBXLabel;
    SpTBXRadioColumnSortDirection: TSpTBXRadioGroup;
    SpTBXCheckBoxFoldersFirst: TSpTBXCheckBox;
    SpTBXButtonColumnColor: TSpTBXButton;
    SpTBXPanelColumnColor: TSpTBXPanel;
    SpTBXCheckBoxListviewHighlightColumn: TSpTBXCheckBox;
    SpTBXGroupBox1: TSpTBXGroupBox;
    SpTBXLabel5: TSpTBXLabel;
    SpTBXEditColumnInHeaderMenu: TSpTBXEdit;
    SpTBXCheckBoxHilightBanding: TSpTBXCheckBox;
    SpTBXButtonHilightBandColor: TSpTBXButton;
    SpTBXPanelHilightBandColor: TSpTBXPanel;
    SpTBXRadioGroupFileSizeStyle: TSpTBXRadioGroup;
    procedure IsDirtyClick(Sender: TObject);
    procedure SpTBXButtonColumnColorClick(Sender: TObject);
    procedure SpTBXEditColumnInHeaderMenuKeyPress(Sender: TObject;
      var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure SpTBXCheckBoxHilightBandingClick(Sender: TObject);
    procedure SpTBXButtonHilightBandColorClick(Sender: TObject);
  end;

implementation

{$R *.DFM}

procedure TTntFormOptionsListviewColumns.IsDirtyClick(
  Sender: TObject);
begin
  SpTBXButtonColumnColor.Enabled := SpTBXCheckBoxListviewHighlightColumn.Checked;
  Dirty(True)
end;

procedure TTntFormOptionsListviewColumns.SpTBXButtonColumnColorClick(
  Sender: TObject);
begin
  ColorDialog.Color := SpTBXPanelColumnColor.Color;
  if ColorDialog.Execute then
  begin
    SpTBXPanelColumnColor.Color := ColorDialog.Color;
    SpTBXPanelColumnColor.Color := ColorDialog.Color;
    SpTBXPanelColumnColor.InvalidateBackground(True);
    SpTBXPanelColumnColor.Invalidate;
    Invalidate;
    Dirty(True)
  end
end;

procedure TTntFormOptionsListviewColumns.SpTBXEditColumnInHeaderMenuKeyPress(
  Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and not( (Key = Char(VK_BACK)) or (Key = Char(VK_DELETE)) ) then
  begin
    Key := #0;
    if (Key <> #13) then
      Beep
  end
end;

procedure TTntFormOptionsListviewColumns.FormShow(Sender: TObject);
begin
  inherited;
  ClientWidth := SpTBXPanel1.Width;
  ClientHeight := SpTBXPanel1.Height;
end;

procedure TTntFormOptionsListviewColumns.SpTBXCheckBoxHilightBandingClick(Sender: TObject);
begin
  SpTBXButtonHilightBandColor.Enabled := SpTBXCheckBoxHilightBanding.Checked;
  Dirty(True);
end;

procedure TTntFormOptionsListviewColumns.SpTBXButtonHilightBandColorClick(
  Sender: TObject);
begin
  ColorDialog.Color := SpTBXPanelHilightBandColor.Color;
  if ColorDialog.Execute then
  begin
    SpTBXPanelHilightBandColor.Color := ColorDialog.Color;
    SpTBXPanelHilightBandColor.InvalidateBackground(True);
    SpTBXPanelHilightBandColor.Invalidate;
    Invalidate;
    Dirty(True)
  end
end;

end.
