unit UnitOptionsListviewThumbnails;

// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you maynot use this file except in compliance
// with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
//
// Alternatively, you may redistribute this library, use and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software Foundation;
// either version 2.1 of the License, or (at your option) any later version.
// You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
// specific language governing rights and limitations under the License.

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  TntForms,
  SpTBXEditors,
  StdCtrls,
  SpTBXControls,
  SpTBXDkPanels,
  DKLang,
  TntDialogs,
  UltraOptions,
  UnitOptionsBase, SpTBXItem;

type
  TTntFormOptionsListviewThumbnails = class(TTntOptionsBaseForm)
    DKLanguageController1: TDKLanguageController;
    SpTBXPanel1: TSpTBXPanel;
    SpTBXGroupBoxListviewThumbnail: TSpTBXGroupBox;
    SpTBXCheckBoxListviewThumbsLoadAll: TSpTBXCheckBox;
    SpTBXLabel9: TSpTBXLabel;
    SpTBXLabel10: TSpTBXLabel;
    SpTBXSpinEditListviewThumbsWidth: TSpTBXSpinEdit;
    SpTBXSpinEditListviewThumbsHeight: TSpTBXSpinEdit;
    SpTBXCheckBoxCacheSingleFile: TSpTBXCheckBox;
    SpTBXButtonEditListviewThumbsCacheFile: TSpTBXButtonEdit;
    SpTBXCheckBoxThumbsCache: TSpTBXCheckBox;
    SpTBXCheckBoxListviewThumbsCompress: TSpTBXCheckBox;
    TntOpenDialog: TTntOpenDialog;
    SpTBXCheckBoxHideCaption: TSpTBXCheckBox;
    SpTBXLabel1: TSpTBXLabel;
    SpTBXEditAspectRatio: TSpTBXEdit;
    SpTBXCheckBoxAutoOrient: TSpTBXCheckBox;
    procedure SpTBXButtonEditListviewThumbsCacheFileSubEditButton0Click(Sender: TObject);
    procedure IsDirtyEvent(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpTBXEditAspectRatioKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure UpdateControls;
  end;

implementation

{$R *.DFM}

procedure TTntFormOptionsListviewThumbnails.SpTBXButtonEditListviewThumbsCacheFileSubEditButton0Click(
  Sender: TObject);
begin
  TntOpenDialog.FileName := SpTBXButtonEditListviewThumbsCacheFile.Text;
  if TntOpenDialog.Execute then
  begin
    SpTBXButtonEditListviewThumbsCacheFile.Text := TntOpenDialog.FileName;
    Dirty(True)
  end
end;

procedure TTntFormOptionsListviewThumbnails.IsDirtyEvent(
  Sender: TObject);
begin
  Dirty(True);
  UpdateControls;
end;

procedure TTntFormOptionsListviewThumbnails.UpdateControls;
begin
  if Assigned(SpTBXCheckBoxListviewThumbsCompress) and Assigned(SpTBXCheckBoxThumbsCache) and Assigned(SpTBXCheckBoxCacheSingleFile) then
  begin
    SpTBXCheckBoxListviewThumbsCompress.Enabled := SpTBXCheckBoxThumbsCache.Checked;
    SpTBXCheckBoxCacheSingleFile.Enabled := SpTBXCheckBoxThumbsCache.Checked;
    SpTBXButtonEditListviewThumbsCacheFile.Enabled := SpTBXCheckBoxCacheSingleFile.Checked
  end
end;


procedure TTntFormOptionsListviewThumbnails.FormShow(Sender: TObject);
begin
  UpdateControls;
  ClientWidth := SpTBXPanel1.Width;
  ClientHeight := SpTBXPanel1.Height;
end;

procedure TTntFormOptionsListviewThumbnails.SpTBXEditAspectRatioKeyPress(
  Sender: TObject; var Key: Char);
begin
  inherited;
  if (Key in ['0'..'9', '.', Char(VK_RETURN), Char(VK_BACK)]) then
  begin
    if Key = Char(VK_RETURN) then
      Key := #0
  end else
  begin
    Key := #0;
    beep;
  end
end;

procedure TTntFormOptionsListviewThumbnails.FormCreate(Sender: TObject);
begin
  inherited;
  SpTBXSpinEditListviewThumbsWidth.SpinOptions.MaxValue := Screen.Width;
  SpTBXSpinEditListviewThumbsHeight.SpinOptions.MaxValue := Screen.Height;
end;

end.
