unit UnitOptionsMouse;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  TntForms,
  SpTBXControls,
  DKLang,
  SpTBXDkPanels,
  UnitOptionsBase, StdCtrls, TntStdCtrls, SpTBXEditors, SpTBXItem;

type
  TTntFormOptionsMouse = class(TTntOptionsBaseForm)
    SpTBXPanelBkGnd: TSpTBXPanel;
    SpTBXGroupBoxRightButton: TSpTBXGroupBox;
    SpTBXRadioButtonDragSelect: TSpTBXRadioButton;
    SpTBXRadioButtonGesture: TSpTBXRadioButton;
    SpTBXComboBoxGestureForward: TSpTBXComboBox;
    SpTBXLabelGestureForward: TSpTBXLabel;
    SpTBXComboBoxGestureBack: TSpTBXComboBox;
    SpTBXLabelGestureBack: TSpTBXLabel;
    SpTBXComboBoxGestureUp: TSpTBXComboBox;
    SpTBXLabelGestureUp: TSpTBXLabel;
    DKLanguageController1: TDKLanguageController;
    SpTBXLabelGestureNewTab: TSpTBXLabel;
    SpTBXComboBoxGestureNewTab: TSpTBXComboBox;
    procedure SpTBXComboBoxGestureChange(Sender: TObject);
    procedure SpTBXRadioButtonGestureClick(Sender: TObject);
    procedure SpTBXRadioButtonDragSelectClick(Sender: TObject);
  private
    { Private declarations }
  protected
    procedure GestureDirty;
    procedure TestForDisabledControls;
  public
    { Public declarations }
  end;

implementation

{$R *.dfm}

procedure TTntFormOptionsMouse.GestureDirty;
begin
  IsDirty(True)
end;

procedure TTntFormOptionsMouse.SpTBXComboBoxGestureChange(
  Sender: TObject);
begin
  GestureDirty
end;

procedure TTntFormOptionsMouse.SpTBXRadioButtonGestureClick(
  Sender: TObject);
begin
  TestForDisabledControls;
  IsDirty(True)
end;

procedure TTntFormOptionsMouse.TestForDisabledControls;
begin
  SpTBXLabelGestureUp.Enabled := SpTBXRadioButtonGesture.Checked;
  SpTBXLabelGestureBack.Enabled := SpTBXRadioButtonGesture.Checked;
  SpTBXLabelGestureForward.Enabled := SpTBXRadioButtonGesture.Checked;
  SpTBXLabelGestureNewTab.Enabled := SpTBXRadioButtonGesture.Checked;
  SpTBXComboBoxGestureUp.Enabled := SpTBXRadioButtonGesture.Checked;
  SpTBXComboBoxGestureBack.Enabled := SpTBXRadioButtonGesture.Checked;
  SpTBXComboBoxGestureForward.Enabled := SpTBXRadioButtonGesture.Checked;
  SpTBXComboBoxGestureNewTab.Enabled := SpTBXRadioButtonGesture.Checked;
end;

procedure TTntFormOptionsMouse.SpTBXRadioButtonDragSelectClick(
  Sender: TObject);
begin
  TestForDisabledControls;
  IsDirty(True)
end;

end.
