unit UnitOptionsTreeview;

// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you maynot use this file except in compliance
// with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
//
// Alternatively, you may redistribute this library, use and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software Foundation;
// either version 2.1 of the License, or (at your option) any later version.
// You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
// specific language governing rights and limitations under the License.

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  DKLang,
  StdCtrls,
  SpTBXEditors,
  SpTBXControls,
  SpTBXDkPanels,
  TntForms,
  UltraOptions,
  UnitOptionsBase, SpTBXItem;

type
  TTntFormOptionsTreeview = class(TTntOptionsBaseForm)
    DKLanguageController1: TDKLanguageController;
    SpTBXPanel1: TSpTBXPanel;
    SpTBXGroupBoxGeneral: TSpTBXGroupBox;
    SpTBXCheckBoxTreeviewHoverAutoExpand: TSpTBXCheckBox;
    SpTBXCheckBoxTreeviewAutoHorzScroll: TSpTBXCheckBox;
    SpTBXCheckBoxTreeviewBranchLines: TSpTBXCheckBox;
    SpTBXCheckBoxTreeviewHotTrack: TSpTBXCheckBox;
    SpTBXCheckBoxTreeviewFullRowSelect: TSpTBXCheckBox;
    SpTBXCheckBoxTreeviewSingleClickExpand: TSpTBXCheckBox;
    SpTBXCheckBoxTreeviewShowToolTip: TSpTBXCheckBox;
    SpTBXGroupBoxTreeviewColors: TSpTBXGroupBox;
    SpTBXButtonTreeviewBkGndColor: TSpTBXButton;
    SpTBXButtonTreeviewFont: TSpTBXButton;
    SpTBXEditTreeviewSample: TSpTBXEdit;
    SpTBXCheckBoxHilightCompressedFolders: TSpTBXCheckBox;
    SpTBXCheckBoxHilightEncryptedFiles: TSpTBXCheckBox;
    SpTBXCheckBoxAlwaysCollapseFirst: TSpTBXCheckBox;
    procedure SpTBXButtonTreeviewBkGndColorClick(Sender: TObject);
    procedure SpTBXButtonTreeviewFontClick(Sender: TObject);
    procedure SpTBXCheckBoxDirtyClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  end;

implementation

{$R *.dfm}

procedure TTntFormOptionsTreeview.SpTBXButtonTreeviewBkGndColorClick(
  Sender: TObject);
begin
  TempColor := SpTBXEditTreeviewSample.Color;
  if QueryModifyColor(FTempColor) then
  begin
    if LockAllColors then
      SetAllWindowColors(ColorDialog.Color)
    else
      SpTBXEditTreeviewSample.Color := ColorDialog.Color;
    Dirty(True)
  end
end;

procedure TTntFormOptionsTreeview.SpTBXButtonTreeviewFontClick(
  Sender: TObject);
begin
  TempFont.Assign(SpTBXEditTreeviewSample.Font);
  if QueryModifyFont(TempFont) then
  begin
    if LockAllFonts then
      SetAllWindowFonts(TempFont)
    else
      SpTBXEditTreeviewSample.Font.Assign(TempFont);
    Dirty(True)
  end
end;

procedure TTntFormOptionsTreeview.SpTBXCheckBoxDirtyClick(
  Sender: TObject);
begin
  Dirty(True)
end;

procedure TTntFormOptionsTreeview.FormShow(Sender: TObject);
begin
  inherited;
  ClientWidth := SpTBXPanel1.Width;
  ClientHeight := SpTBXPanel1.Height;
end;

end.
