unit UnitPluginColumnsModeFrame;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  UnitPlugInBaseFrame,
  UnitTabSetFrame,
  MPCommonObjects,
  EasyListview,
  VirtualExplorerEasyListview,
  VirtualExplorerEasyListModeview,
  ImgList;

type
  TTntFramePlugInColumnMode = class(TTntFrameBasePlugIn)
    VirtualColumnModeView1: TVirtualColumnModeView;
    ImageList1: TImageList;
  private
    { Private declarations }
    FTabFrame: TTntFrameTabs;
  protected
    procedure WMShowWindow(var Msg: TWMShowWindow); message WM_SHOWWINDOW;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    function TabCaption(var ACaption: WideString): Boolean; override;
    function TabImage(var AnImageList: TCustomImageList; var AnImageIndex: Integer): Boolean; override;
    property TabFrame: TTntFrameTabs read FTabFrame write FTabFrame;
  end;


implementation

{$R *.dfm}

{ TTntFramePlugInColumnMode }
constructor TTntFramePlugInColumnMode.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  TabFrame := TTntFrameTabs.Create(Self);
  TabFrame.Align := alTop;
  TabFrame.Parent := Self
end;

function TTntFramePlugInColumnMode.TabCaption(var ACaption: WideString): Boolean;
begin
  ACaption := 'Column View PlugIn';
  Result := True
end;

function TTntFramePlugInColumnMode.TabImage(var AnImageList: TCustomImageList; var AnImageIndex: Integer): Boolean;
begin
  AnImageList := ImageList1;
  AnImageIndex := 0;
  Result := True;
end;

procedure TTntFramePlugInColumnMode.WMShowWindow(var Msg: TWMShowWindow);
begin
  inherited;
  VirtualColumnModeView1.Active := True
end;

initialization
  RegisterClass(TTntFramePlugInColumnMode);

finalization

end.
