unit UnitSearchBrowseTaskPanel;

// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you maynot use this file except in compliance
// with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
//
// Alternatively, you may redistribute this library, use and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software Foundation;
// either version 2.1 of the License, or (at your option) any later version.
// You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
// specific language governing rights and limitations under the License.
                                                                  
interface                                                         
                                                                  
                                                                  
uses                                                              
  Windows,
  Messages,
  SysUtils,
  Classes,
  Controls,
  Forms,
  Dialogs,
  Graphics,
  EasyTaskPanelForm,
  VirtualTrees,
  VirtualExplorerTree,
  SpTBXDkPanels,
  MPThreadManager,
  SpTBXControls,
  UltraUtilities,
  TntSysUtils,
  MPShellUtilities,
  MPCommonUtilities,
  DKLang, SpTBXItem;
                                                    
                                                                  
type                                                              
  TEasyTaskPanelFormBrowse = class(TEasyTaskPanelForm)
    SpTBXPanelBrowse: TSpTBXPanel;
    DKLanguageController: TDKLanguageController;
    VETSearch: TVirtualExplorerTreeview;
    procedure EasyTaskPanelFormShow(Sender: TObject);
    procedure VETSearchEnumFolder(Sender: TCustomVirtualExplorerTree;
      Namespace: TNamespace; var AllowAsChild: Boolean);
    procedure VETSearchInitNode(Sender: TBaseVirtualTree; ParentNode,
      Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
  private
    { Private declarations }                                      
  public                                                          
    { Public declarations }                                       
    procedure LoadSearchData(var Data: TUltraSearchAttribs);
  end;                                                            
                                                                  
var                                                               
  EasyTaskPanelFormBrowse: TEasyTaskPanelFormBrowse;

implementation                                                    
                                                                 
{$R *.dfm}
                                                                  
                                                                  
procedure TEasyTaskPanelFormBrowse.EasyTaskPanelFormShow(Sender: TObject);
begin
  FixFormFont(VETSearch.Font);
  ClientWidth := SpTBXPanelBrowse.Width;
  ClientHeight := SpTBXPanelBrowse.Height;
end;

procedure TEasyTaskPanelFormBrowse.LoadSearchData(var Data: TUltraSearchAttribs);
var
  NS: TNamespace;
  Node: PVirtualNode;
begin
  Data.SearchFolders.Clear;
  Node := VETSearch.GetFirstChecked;
  while Assigned(Node) do
  begin
    if VETSearch.ValidateNamespace(Node, NS) then
    begin
      if WideDirectoryExists(NS.NameForParsing) then
        Data.SearchFolders.Add(NS.NameForParsing)
    end;
    Node := VETSearch.GetNextChecked(Node)
  end
end;

procedure TEasyTaskPanelFormBrowse.VETSearchEnumFolder(
  Sender: TCustomVirtualExplorerTree; Namespace: TNamespace;
  var AllowAsChild: Boolean);
begin
  // No custom browsable folders (like the zip extension)
  AllowAsChild := not Namespace.Browsable
end;

procedure TEasyTaskPanelFormBrowse.VETSearchInitNode(
  Sender: TBaseVirtualTree; ParentNode, Node: PVirtualNode;
  var InitialStates: TVirtualNodeInitStates);
begin
  Node.CheckType := ctTriStateCheckBox
end;

end.
