unit UnitSearchSizeTaskPanel;

// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you maynot use this file except in compliance
// with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
//
// Alternatively, you may redistribute this library, use and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software Foundation;
// either version 2.1 of the License, or (at your option) any later version.
// You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
// specific language governing rights and limitations under the License.
                                                                  
interface                                                         
                                                                  

uses                                                              
  Windows,
  Messages,
  SysUtils,
  Classes,
  Controls,
  Forms,
  Dialogs,
  Graphics,
  EasyTaskPanelForm,
  SpTBXControls,
  StdCtrls,
  SpTBXEditors,
  TntStdCtrls,
  UltraUtilities,
  MPCommonUtilities,
  DKLang, SpTBXItem;
                                                    
                                                                  
type                                                              
  TEasyTaskPanelFormSearchSize= class(TEasyTaskPanelForm)
    SpTBXPanelSearchSize: TSpTBXPanel;
    SpTBXRadioGroupSearchSize: TSpTBXRadioGroup;
    SpTBXComboBoxSize: TSpTBXComboBox;
    SpTBXSpinEditSize: TSpTBXSpinEdit;
    DKLanguageController: TDKLanguageController;
    procedure EasyTaskPanelFormShow(Sender: TObject);
    procedure SpTBXRadioGroupSearchSizeClick(Sender: TObject);
  private                                                         
    { Private declarations }                                      
  public                                                          
    { Public declarations }
    procedure LoadSearchData(var Data: TUltraSearchAttribs);                                   
  end;                                                            
                                                                  
var                                                               
  EasyTaskPanelFormSearchSize: TEasyTaskPanelFormSearchSize;
                                                                  
implementation                                                    

{$R *.dfm}                                                        
                                                                  
                                                                  
procedure TEasyTaskPanelFormSearchSize.EasyTaskPanelFormShow(
  Sender: TObject);
begin
  FixFormFont(Font);
  ClientWidth := SpTBXPanelSearchSize.Width;
  ClientHeight := SpTBXPanelSearchSize.Height;
  SpTBXSpinEditSize.SpinOptions.MaxValue := High(Int64);
end;

procedure TEasyTaskPanelFormSearchSize.LoadSearchData(var Data: TUltraSearchAttribs);
begin
  Data.Masks := Data.Masks - [samSizeMask];
  Data.Size := 0;

  if SpTBXRadioGroupSearchSize.ItemIndex > 0 then
  begin
    Data.Masks := Data.Masks + [samSizeMask];
    case SpTBXRadioGroupSearchSize.ItemIndex of
      1: begin
           Data.Size := 100000;
           Data.SizeCompare := fcsNoMore;
         end;
      2: begin
           Data.Size := 1000000;
           Data.SizeCompare := fcsNoMore;
         end;
      3: begin
           Data.Size := 1000000;
           Data.SizeCompare := fscAtLeast;
         end;
      4: begin
           Data.Size := SpTBXSpinEditSize.SpinOptions.ValueAsInteger;
           Data.SizeCompare := TUltraFileSizeCompare( SpTBXComboBoxSize.ItemIndex);
         end
    end
  end
end;

procedure TEasyTaskPanelFormSearchSize.SpTBXRadioGroupSearchSizeClick(
  Sender: TObject);
begin
  SpTBXComboBoxSize.Enabled := SpTBXRadioGroupSearchSize.ItemIndex = 4;
  SpTBXSpinEditSize.Enabled := SpTBXRadioGroupSearchSize.ItemIndex = 4;
end;

end.
